<?
if (!defined("NS_TRACKER_INDEX")) exit;
define("CRON_MODE", true);
if (!V($Db->ID)) exit;
if ($nsProduct->VERSION!=$TrackerVersion) exit;

require_once SELF. '/lib/cron/cron.func.php';

$Db->LoggerFunc="";
$Tasks=array("DELAYED", "DELETE", "CACHE", "XML", "EMAIL");
$AvailTasks=array();
$TasksInProgress=array();
$CurrentTask="";

$SetSleepMessageFunc="";
$UpdateCronLogFunc="";


$CronComments=V($_REQUEST['debug']);
define("NO_CRON_COMMENTS",($CronComments)?false:true);
if (!NO_CRON_COMMENTS && function_exists('ini_set')) {
    @ini_set('error_reporting',E_ALL);
    @ini_set('display_errors','on');
}


$Settings=GetSettings();
if (!$Settings['All']->CRON_ENABLE) NO_CRON_COMMENTS?exit():die("Cron is not enabled\n");
$Stamp=gmdate("U", time());
$GmTime=gmdate("Y-m-d H:i:s", time());

$SkipTimePeriods=@$Settings['All']->CRON_SKIP_TIME;
if ($SkipTimePeriods && CheckSkipTime($SkipTimePeriods)) NO_CRON_COMMENTS?exit():die("Bad time for cron launch\n");

$Query = "UPDATE ?_cron_log SET FINISHED = '1' WHERE FINISHED = '0' AND
    TO_STOP IS NOT NULL AND TO_STOP < DATE_ADD(?, INTERVAL -5 MINUTE)";
$Db->Query($Query, $GmTime);

$Query = "
    SELECT *, UNIX_TIMESTAMP(STAMP)  AS USTAMP,
    (UNIX_TIMESTAMP('$GmTime') - UNIX_TIMESTAMP(STAMP)) AS DIFF  
    FROM ?_cron_log 
    WHERE FINISHED='0' ORDER BY STAMP ASC";
$Sql = new Query($Query);
$LastStamp=false;
while ($Row=$Sql->Row()) {
    if ($Row->DIFF/60/60>1) {
        $Query = "UPDATE ?_cron_log SET FINISHED='1' WHERE ID=?";
        $Db->Query($Query,$Row->ID);
        continue;
    }
    $LastStamp=$Row->USTAMP;
    $TasksInProgress[]=$Row->TASK;
}
foreach ($Tasks as $Task) if (!in_array($Task,$TasksInProgress)) $AvailTasks[]=$Task;
if (empty($AvailTasks)) NO_CRON_COMMENTS?exit():die("No tasks available");

$CustomCronTasks=array();
$Query = "SELECT * FROM ?_cron_task";
$Sql = new Query($Query);
while ($Row=$Sql->Row()) $CustomCronTasks[$Row->TASK_TYPE]=$Row->TASK;

foreach ($AvailTasks as $CurrentTask) {
    $AvgArr=array();
    $Query = "SELECT UNIX_TIMESTAMP(STAMP) AS STAMP FROM ?_cron_log ORDER BY ID DESC LIMIT 10";
    $Sql = new Query($Query);
    $PrevStamp=0;
    $PrevCronTime=0;
    while ($Row=$Sql->Row()) {
        if ($PrevStamp) $AvgArr[]= $Row->STAMP-$PrevStamp;
        $PrevStamp=$Row->STAMP;
    }
    if (!empty($AvgArr)) $PrevCronTime=ceil(array_sum($AvgArr)/count($AvgArr));
    $CurrentTaskId=StartCronTask($CurrentTask);
    $CronStartTime=$Db->GetMicrotime();
    if (!$PrevCronTime) $PrevCronTime=$CronStartTime-60;
    $PrevCronDuration=$CronStartTime-$PrevCronTime;
    if (!$PrevCronDuration) $PrevCronDuration=1;

    switch ($CurrentTask) {
        case "DELAYED": {
            if (count(array_intersect(array('CACHE', 'XML', 'DELETE'), $AvailTasks))==3) include_once SELF."/actions/cron.delayed.php";
            break;
        }
        case "CACHE": {
            if (count(array_intersect(array('DELAYED', 'DELETE'), $AvailTasks))==2 && !@$CustomCronTasks['XML']) include_once SELF."/actions/cron.cache.php";
            break;
        }
        case "DELETE": {
            if (count(array_intersect(array('DELAYED', 'CACHE'), $AvailTasks))==2 && !@$CustomCronTasks['XML']) include_once SELF."/actions/cron.delete.php";
            break;
        }
        case "XML": {
            if (count(array_intersect(array('DELAYED', 'DELETE', 'CACHE'), $AvailTasks))==3) include_once SELF."/actions/cron.xml.php";
            break;
        }
        case "EMAIL": {
            if (count(array_intersect(array('DELAYED', 'DELETE', 'CACHE'), $AvailTasks))==3) include_once SELF."/actions/cron.email.php";
            break;
        }        
    }

    FinishCronTask();
}

?>