<?
if (!defined("NS_TRACKER_INDEX")) exit;
if (!defined("CRON_MODE")) exit;
if (function_exists("ini_set")) @set_time_limit(0);
if ($nsProduct->VERSION!=$TrackerVersion) exit;
$SetSleepMessageFunc="SetDeleteSleepMessage";
$AddFinishFunc="EnableTracking";
$TableRowSpace=array();
$CurrentTask='DELETE';

require_once SELF. '/lib/cron/cron.func.php';
require_once SELF."/lib/delete/period.func.php";
require_once SELF."/lib/delete/delete.func.php";
require_once SELF."/lib/reports/do_cache.func.php";

if (!NO_CRON_COMMENTS) echo "Archiving and removing... \n";

while (ArchiveStat()) {}
CronDeleteStat();

function ArchiveStat($NoComment=NO_CRON_COMMENTS)
{
    if (!defined("CRON_MODE")) return false;
    global $Db, $Settings,$CronStartTime,$PrevCronDuration,$nsUser,$SetSleepMessageFunc;
    $SetSleepMessageFunc="SetArchiveSleepMessage";
    if (!$Settings['All']->ARCHIVE_ENABLE) return false;
    $Now=gmdate("Y-m-d H:i:s", time());
    static $Iter=0;
    if (@$Settings['All']->ARCHIVE_ROWS) $Settings['All']->CACHE_ROWS_CNT = $Settings['All']->ARCHIVE_ROWS;

    $Query = "
            SELECT C.ID, CO.TIMEZONE
            FROM ?_client C
                INNER JOIN ?_config CO ON CO.COMPANY_ID=C.ID AND CO.SITE_ID=0
            ORDER BY C.ID
    ";
    $Sql = new Query($Query);
    $ClientArr=array();
    $ClientTZ=array();
    while ($Row=$Sql->Row()) {
        $ClientArr[]=$Row->ID;
        $ClientTZ[$Row->ID]=$Row->TIMEZONE;
    }

    $Archives=array();
    foreach ($ClientArr as $CpId) {
        $Query = "
            SELECT C.*,
                DATE_FORMAT(AC.NEXT_ARCHIVE_START_DATE,'%Y-%m-%d') AS START_DATE,
                DATE_FORMAT(AC.NEXT_ARCHIVE_END_DATE,'%Y-%m-%d') AS END_DATE,
                AC.SITE_ID,
                SA.PERIOD, SA.ID AS PERIOD_ID, 
                A.ID AS ARCHIVE_ID,
                SR.ID AS REPORT_ID,
                SR.ADDITIONAL_TASK, SR.SITES, SR.MODE,
                QS.PARAMS_SET

            FROM ?_{$CpId}_static_archive_cache AC
            INNER JOIN ?_static_report_archive SA
                ON SA.ID=AC.PERIOD_ID
            INNER JOIN ?_static_report SR
                ON SR.ID=SA.REPORT_ID
            INNER JOIN ?_{$CpId}_cache C
                ON C.ID=AC.CACHE_ID
            INNER JOIN ?_{$CpId}_cache_query_set QS
                ON QS.ID=C.QUERY_SET_ID
            LEFT JOIN ?_archive A
                ON A.COMPANY_ID=$CpId AND A.REPORT_ID=AC.REPORT_ID AND A.SITE_ID=AC.SITE_ID AND
                    A.START_DATE = DATE_FORMAT(AC.NEXT_ARCHIVE_START_DATE,'%Y-%m-%d') AND
                    A.END_DATE=DATE_FORMAT(AC.NEXT_ARCHIVE_END_DATE,'%Y-%m-%d')
            WHERE AC.NEXT_ARCHIVE_END_DATE <= DATE_ADD('$Now',INTERVAL '".SqlTZ($ClientTZ[$CpId])."' HOUR_MINUTE)
            ORDER BY AC.NEXT_ARCHIVE_START_DATE ASC
        ";

        $Sql = new Query($Query);
        while ($Row=$Sql->Row()) {
            $Archives[$CpId][$Row->REPORT_ID][]=$Row;
        }
    }

    $Perc=0;
    $NothingAtAll=true;
    foreach ($Archives as $CpId=>$CpReports) {

        if ($Perc>80) {
            if (!$NoComment) echo "Timeout\n";
            return false;
        }

        foreach ($CpReports as $ReportId=>$CacheArr) {
            $ReportArchived=0;
            foreach ($CacheArr as $Row) {
                if (IsCronTaskFinished()) return false;
                $CpuArr=array();
                if ($Row->ARCHIVE_ID) continue;
                CheckCpuLoad($CpId,$NoComment);
                if (!$NoComment) echo "Report id: {$Row->REPORT_ID}, {$Row->PERIOD}, {$Row->START_DATE} - {$Row->END_DATE}\n";
                $CpuArr[]=GetCpuLoad(false, $NoComment);
                $Time=$Db->GetMicrotime();
                $Data=DoCache($Row, $CpId, $NoComment, $Row->ADDITIONAL_TASK,'DATA');
                $CpuArr[]=GetCpuLoad(false, $NoComment);
                $Time1=$Db->GetMicrotime();
                $Query = "INSERT INTO ?_archive 
                                        (COMPANY_ID,SITE_ID,REPORT_ID,PERIOD,FULL_DATA,
                                            START_DATE,END_DATE,TIMEZONE,PARAMS_SET)
                                        VALUES (?,?,?,?,?,?,?,?,?)";
                $Db->Query($Query,$CpId,$Row->SITE_ID,$Row->REPORT_ID,$Row->PERIOD,(!empty($Data))?$Data:null,
                                            $Row->START_DATE,$Row->END_DATE,V($ClientTZ[$CpId]),$Row->PARAMS_SET);
                $ReportArchived++;
                $Iter=0;
                UpdateCronArchiveLog($CpuArr[1], $CpuArr[0], $CpId, $ReportId, $Row->START_DATE, $Row->END_DATE, $Time1-$Time);
                $NothingAtAll=false;
                if (!$NoComment) echo "\n\n\n";
            }
            if (!$ReportArchived) {
                $Row->ID=$Row->REPORT_ID;
                SetArchivePeriod($Row,array(0=>$CpId),$Row->PERIOD,$Row->PERIOD_ID);
                if (!$NoComment) echo "Update period: {$Row->REPORT_ID}, {$Row->PERIOD}\n";
                $NothingAtAll=false;
            }
        }
        if (!$ReportArchived) $Iter++;
        if ($Iter>5) $NothingAtAll=true;
        $CurrentTime=$Db->GetMicrotime();
        $Diff=$CurrentTime-$CronStartTime;
        $Perc=ceil(100*$Diff/$PrevCronDuration);

        if (!$ReportArchived) {

            $Query = "
                UPDATE ?_{$CpId}_cache C
                     LEFT JOIN ?_{$CpId}_static_archive_cache AC
                        ON AC.CACHE_ID=C.ID
                SET C.CACHE_TYPE=4 WHERE C.CACHE_TYPE=3 AND AC.ID IS NULL";
            $Db->Query($Query);

            $DelCacheArr=array();
            $DelQSArr=array();
            $Query = "SELECT ID,QUERY_SET_ID FROM ?_{$CpId}_cache WHERE CACHE_TYPE=4";
            $Sql = new Query($Query);
            while ($Row=$Sql->Row()) {$DelCacheArr[]=$Row->ID;$DelQSArr[]=$Row->QUERY_SET_ID;}
            if (!empty($DelCacheArr)) {
                $Query = "DELETE FROM ?_{$CpId}_cache WHERE CACHE_TYPE=4";
                $Db->Query($Query);
                $Query = "DELETE FROM ?_{$CpId}_cache_query_set WHERE ID IN (?)";
                $Db->Query($Query,$DelQSArr);
                $Query = "DELETE FROM ?_{$CpId}_cache_data WHERE CACHE_ID IN (?)";
                $Db->Query($Query,$DelCacheArr);
            }
        }
    }

    return !$NothingAtAll;
}





function SetArchiveSleepMessage($CpId=false, $CpuLoad=0)
{
    if (!$CpId) return false;
    global $Db, $CurrentTaskId;
    $Stamp=gmdate("Y-m-d H:i:s", time());
    $Query = "INSERT INTO ?_cron_archive_log (TASK_PROCESS_ID, STAMP, MESSAGE, CPU_LOAD) VALUES (?,?,?,?)";
    $Db->Query($Query, $CurrentTaskId, $Stamp, 'x-sleep', $CpuLoad);    
}

function SetDeleteSleepMessage($CpId=false, $CpuLoad=0)
{
    if (!$CpId) return false;
    global $Db, $CurrentTaskId;
    $Stamp=gmdate("Y-m-d H:i:s", time());
    $Query = "INSERT INTO ?_cron_delete_log (TASK_PROCESS_ID, STAMP, MESSAGE, CPU_LOAD) VALUES (?,?,?,?)";
    $Db->Query($Query, $CurrentTaskId, $Stamp, 'x-sleep', $CpuLoad);    
}

function UpdateCronDeleteLog($CpuLoad=0, $CpuLoadBefore=0, $DeletedRows=0, $Msg='', $RunTime='')
{
    if (!defined("CRON_MODE")) return false;
    global $Db, $Logs, $CurrentTaskId;
    $Stamp=gmdate("Y-m-d H:i:s", time());
    $Err=GetErrText();
    $Query = "INSERT INTO ?_cron_delete_log (TASK_PROCESS_ID, STAMP, DELETED_ROWS,  
                                                                            ERRORS, CPU_LOAD_BEFORE, CPU_LOAD, MESSAGE, RUN_TIME)
                                                                            VALUES (?,?,?,?,?,?,?,?)";
    $Db->Query($Query, $CurrentTaskId, $Stamp, $DeletedRows, ($Err)?$Err:"", 
                                                        $CpuLoadBefore, $CpuLoad, $Msg, $RunTime);
    DisplayErrors();
    $_SESSION['__Errors']=array();
}

function UpdateCronArchiveLog($CpuLoad=0, $CpuLoadBefore=0, $CpId=0, $ReportId=0, $SD='', $ED='', $RunTime='')
{
    if (!defined("CRON_MODE")) return false;
    global $Db, $Logs, $CurrentTaskId;
    $Stamp=gmdate("Y-m-d H:i:s", time());
    $Err=GetErrText();
    $Query = "INSERT INTO ?_cron_archive_log (TASK_PROCESS_ID, STAMP, COMPANY_ID, REPORT_ID,
                                                                            START_DATE, END_DATE, ERRORS, CPU_LOAD_BEFORE, CPU_LOAD, RUN_TIME)
                                                                            VALUES (?,?,?,?,?,?,?,?,?,?)";
    $Db->Query($Query, $CurrentTaskId, $Stamp, $CpId, $ReportId, $SD, $ED, ($Err)?$Err:"", 
                                                        $CpuLoadBefore, $CpuLoad, $RunTime);
    DisplayErrors();
    $_SESSION['__Errors']=array();        
}


?>