<?
if (!defined("NS_TRACKER_INDEX")) exit;
if (function_exists("ini_set")) @set_time_limit(0);
if ($nsProduct->VERSION!=$TrackerVersion) exit;
$CurrentTask='XML';
$AddFinishFunc='UnsetXmlTask';

if (!isset($Settings)) $Settings=GetSettings();
if (!defined("NO_CRON_COMMENTS")) define("NO_CRON_COMMENTS",true);

if (!NO_CRON_COMMENTS) echo "Libraries processing... \n";
if (defined("CRON_MODE") && (!V($CustomCronTasks)||!V($CustomCronTasks['XML']))) {
    return; 
}

require_once SELF. '/lib/cron/cron.func.php';
require_once SELF."/lib/track/referer.func.php";
require_once SELF."/lib/delete/robots.func.php";
require_once SELF."/lib/geo/visitor_location.func.php";
require_once SELF."/class/search_engine.class.php";
require_once SELF."/class/ua_tracker.class.php";
$UAParser = new UATrackerParser(SELF."/xml/");
$SE=new SearchEngine();
$Tables = array('browser'=>array('?_visitor_agent_browser','BROWSER_ID','BROWSER_VERSION'),
                              'os'=>array('?_visitor_agent_os','OS_ID','OS_VERSION'),
                              'engine'=>array('?_visitor_agent_engine','ENGINE_ID','ENGINE_VERSION'),
                              'other'=>array('?_visitor_agent_robot','ROBOT_ID','ROBOT_VERSION'));
$DataTypes=array('browser','os','engine','other');

$StartRow=V($_REQUEST['StartRow']);
$UpdateMode=V($_REQUEST['UpdateMode'],'agent');
$UpdateRowStep=V($_REQUEST['UdpateRowStep']);
if (defined("CRON_MODE")) $UpdateRowStep=false;

$UpdateOptions=V($_REQUEST['UpdateOptions'],array());
if (defined("CRON_MODE")) {
    $Arr=explode("|",$CustomCronTasks['XML']);
    foreach ($Arr as $v) {
        $v=trim($v); if (!$v) continue;
        $UpdateOptions[$v]=1;
    }
}

if (!NO_CRON_COMMENTS) echo "Xml update... \n";

SetXmlTaskInProgress();

if (($StartRow==0 && $UpdateMode=='agent') || defined("CRON_MODE")) {
    if (V($UpdateOptions['UpdateGroups'])) PrepareGroups();
    if (IsCronTaskFinished()) return false;
}
if (($StartRow==0 && $UpdateMode=='search') || defined("CRON_MODE")) {
    if (V($UpdateOptions['UpdateGroups'])) PrepareSearchEngines();
    if (IsCronTaskFinished()) return false;
    if (V($UpdateOptions['UpdateSEngines'])) UpdateHostGrps();
    if (IsCronTaskFinished()) return false;
}
if ($UpdateMode=='agent' || defined("CRON_MODE")) {
    if (V($UpdateOptions['UpdateAgents'])) ParseUserAgents();
    if (IsCronTaskFinished()) return false;
    if (defined("CRON_MODE") && V($UpdateOptions['UpdateAgents'])) UpdateRobotsPaths();
    if (IsCronTaskFinished()) return false;
}
if ($UpdateMode=='search' || defined("CRON_MODE")) {
    if (V($UpdateOptions['UpdateSEngines'])) UpdateRefSet();
    if (IsCronTaskFinished()) return false;
}
if ($UpdateMode=='geo' || defined("CRON_MODE")) {
    if (V($UpdateOptions['UpdateLocations'])) $Upd = UpdateVisitorsLocation();
    if (defined('CRON_MODE') && !NO_CRON_COMMENTS) echo "Geo updated: $Upd\n";
    if (IsCronTaskFinished()) return false;
}



function UnsetXmlTask() {
    global $Db;
    if (!defined("CRON_MODE")) return false;
    $Query = "DELETE FROM ?_cron_task WHERE TASK_TYPE='XML' ";
    $Db->Query($Query);
}

function SetXmlTaskInProgress() {
    global $Db;
    if (!defined("CRON_MODE")) return false;
    $Query = "UPDATE   ?_cron_task SET IN_PROGRESS = '1' WHERE TASK_TYPE='XML' ";
    $Db->Query($Query);    
}

function ParseUserAgents()
{
    global $Db, $UAParser,$DataTypes,$Tables;
    global $StartRow,$UpdateRowStep;
    $ClassVersions=array('browser'=>'BrowserVersion','os'=>'OSVersion','engine'=>'EngineVersion','other'=>'OtherVersion');
    foreach ($DataTypes as $tp) $IDs[$tp]=GetElements($tp);
    $LimitStr=($UpdateRowStep)?"LIMIT $StartRow, $UpdateRowStep":"";
    $Query = "SELECT * FROM ?_visitor_agent ORDER BY ID ASC $LimitStr";
    $Sql = new Query($Query);
    while ($Row=$Sql->Row()) {
        $UpdateArr=array();
        $UA=$UAParser->ParseUA($Row->USER_AGENT);
        foreach ($DataTypes as $tp) {
            if (isset($UA['Data'][$tp]) && (!$UA['PotentialBot'] || $UA['Other']))  {
                $UpdateArr[  $Tables[$tp][1]  ] = $IDs[$tp][  $UA['Data'][$tp]['key']  ]->ID;
                $UpdateArr[  $Tables[$tp][2]  ] = $UA[ $ClassVersions[$tp] ];
            }
            else {
                $UpdateArr[  $Tables[$tp][1]  ] = 0;
                $UpdateArr[  $Tables[$tp][2]  ] = '';
            }
        }
        if ($Row->BROWSER_ID==@$UpdateArr['BROWSER_ID'] && 
            $Row->BROWSER_VERSION==@$UpdateArr['BROWSER_VERSION'] &&
            $Row->OS_ID==@$UpdateArr['OS_ID'] && 
            $Row->OS_VERSION==@$UpdateArr['OS_VERSION'] &&
            $Row->ROBOT_ID==@$UpdateArr['ROBOT_ID'] && 
            $Row->ROBOT_VERSION==@$UpdateArr['ROBOT_VERSION']) continue; 
        $Query = "UPDATE ?_visitor_agent SET ?% WHERE ID=?";
        $Db->Query($Query,$UpdateArr,$Row->ID);
        if (!NO_CRON_COMMENTS && (@$UA['Browser'] || @$UA['OS']))
            echo "{$UA['Browser']} ({$UA['BrowserVersion']}), {$UA['OS']} ({$UA['OSVersion']})\n";
    }
}

function UpdateRobotsPaths()
{
    $Query = "SELECT ID FROM ?_client";
    $ClientArr=array();
    $Sql = new Query($Query);
    while ($Row=$Sql->Row()) $ClientArr[]=$Row->ID;
    $Modified=0;
    foreach ($ClientArr as $CpId) $Modified+=MoveVisitorsToRobots($CpId);
    if (!NO_CRON_COMMENTS) echo "Robots moved: $Modified\n";
}

function GetElements($ElemType=false)
{
    if (!$ElemType) return array();
    global $Db,$Tables;
    $Table=$Tables[$ElemType][0];
    $Arr=array();
    $Query = "SELECT * FROM $Table";
    $Sql = new Query($Query);
    while ($Row=$Sql->Row()) $Arr[$Row->NAME_KEY]=$Row;
    return $Arr;
}

function PrepareGroups()
{
    global $Db, $UAParser,$DataTypes;
    foreach ($DataTypes as $tp) {
        $UAParser->LoadXmlData($tp.'.xml');
        PrepareElements($tp);
    }
}

function PrepareElements($ElemType='')
{
    if (!$ElemType ) return false;
    global $Db, $UAParser,$Tables;
    $Table=$Tables[$ElemType][0];
    
    if (empty($UAParser->XMLData[$ElemType])) {
        $Query = "DELETE FROM $Table";
        $Db->Query($Query);
        $Query  = "UPDATE ?_visitor_agent SET {$Tables[$ElemType][1]}=0, {$Tables[$ElemType][2]}='' ";
        $Db->Query($Query);
        return false;
    }

    $Keys=array_keys($UAParser->XMLData[$ElemType]);    
    $Query = "SELECT NAME_KEY FROM $Table WHERE NAME_KEY IN (?)";
    $Sql = new Query($Query,false,$Keys);
    $CheckKeys=array();
    while ($Row=$Sql->Row()) $CheckKeys[]=$Row->NAME_KEY;
    $Query = "DELETE FROM $Table WHERE NAME_KEY NOT IN (?)";
    $Db->Query($Query,$Keys);
    $DiffKeys=array_diff($Keys,$CheckKeys);
    foreach ($DiffKeys as $Key) {
        if (!NO_CRON_COMMENTS) echo "Creating element: {$UAParser->XMLData[$ElemType][$Key]['name']}\n";
        $Query = "INSERT INTO $Table (NAME_KEY,NAME) VALUES (?,?)";
        $Db->Query($Query,$Key,$UAParser->XMLData[$ElemType][$Key]['name']);
        $Id=$Db->LastInsertId;
        if (isset($UAParser->XMLData[$ElemType][$Key][$ElemType.'_type'])) {
            $Query = "UPDATE $Table SET ELEM_TYPE=? WHERE ID=?";
            $Db->Query($Query,$UAParser->XMLData[$ElemType][$Key][$ElemType.'_type'],$Id);
        }
    }
}

function PrepareSearchEngines()
{
    global $Db,$SE;
    
    $Query = "SELECT * FROM ?_host_grp";
    $Sql = new Query($Query);
    $Grp=array(); $Keys=array(); $Names=array();
    while ($Row=$Sql->Row()) {
        $Grp[$Row->NAME_KEY]=$Row;
        $Keys[]=$Row->NAME_KEY;
        $Names[$Row->ID]=strtolower($Row->NAME);
    }
    
    foreach ($SE->XMLData as $Key=>$Arr) {
        $GrpId=false;
        if (!in_array($Key,$Keys)) {
            foreach ($Names as $Id=>$Name) {
                if ($Name!=strtolower($Arr['name'])) continue;
                $GrpId=$Id;
                break;
            }
            if (!$GrpId) {            
                $Query = "INSERT INTO ?_host_grp (NAME_KEY,NAME) VALUES (?,?)";
                $Db->Query($Query,$Key,$Arr['name']);
            }
            else {
                $Query = "UPDATE ?_host_grp SET NAME_KEY=?, NAME=? WHERE ID=?";
                $Db->Query($Query,$Key,$Arr['name'],$GrpId);
            }
        }
        else {
            $GrpId=$Grp[$Key]->ID;
            $Query = "UPDATE ?_host_grp SET NAME_KEY=?, NAME=? WHERE ID=?";
            $Db->Query($Query,$Key,$Arr['name'],$GrpId);
        }
    }
}


function UpdateHostGrps()
{
    global $Db, $SE;

    $Query = "SELECT * FROM ?_host_grp WHERE NAME_KEY != '' ";
    $S = new Query($Query);
    while ($Grp=$S->Row()) {
        if (!NO_CRON_COMMENTS) echo "{$Grp->NAME}: ";
        if (!isset($SE->XMLData[$Grp->NAME_KEY])) continue;
        $Arr=$SE->XMLData[$Grp->NAME_KEY];
        preg_match('/#([^#]+)#/',$Arr['reg'],$Res);
        $Reg=@$Res[1];
        $Query = "SELECT * FROM ?_host WHERE HOST REGEXP ?";
        $Sql = new Query($Query,false,$Reg);
        $Updated=0;
        while ($Row=$Sql->Row()) {
            if (@$Arr['reg_not'] && preg_match($Arr['reg_not'],$Row->HOST)) continue;
            $Query = "UPDATE ?_host SET GRP_ID=? WHERE ID=?";
            $Db->Query($Query,$Grp->ID,$Row->ID);
            $Updated++;
        }
        if (!NO_CRON_COMMENTS) echo "$Updated\n";
    }
}

function UpdateRefSet()
{
    global $Db,$SE,$StartRow,$UpdateRowStep;
    $LimitStr=($UpdateRowStep)?"LIMIT $StartRow, $UpdateRowStep":"";
    $Query = "
        SELECT RS.ID, R.REFERER, HG.NAME_KEY
        FROM ?_referer_set RS
        INNER JOIN ?_host H ON H.ID=RS.HOST_ID
        INNER JOIN ?_host_grp HG ON HG.ID=H.GRP_ID
        INNER JOIN ?_referer R ON R.ID=RS.REFERER_ID
        WHERE RS.NATURAL_KEY = 0 AND HG.NAME_KEY != '' 
        $LimitStr
    ";
    $Sql = new Query($Query);
    while ($Row=$Sql->Row()) {
        $SE->SetReferer($Row->REFERER);
        $SE->HostGrpKey=$Row->NAME_KEY;
        $SE->AnalyzeData();
        if (!$SE->Keyword) continue;
        $KeyId=NS_TRACK_REFERER::GetKeywordId($SE->Keyword);
        $Query = "UPDATE ?_referer_set SET NATURAL_KEY=? WHERE ID=?";
        $Db->Query($Query,$KeyId,$Row->ID);
        if (!NO_CRON_COMMENTS) echo "{$SE->HostGrpKey} -- {$SE->Keyword}\n";
    }
}

?>