<?
/*
 * UserAgent parser
 * author: johann kuindji (www.kuindji.com)
 * (c) Stuffed Guys (www.stuffedguys.com)
 */

class UAParser {

function UAParser($PathToXML='')
{
    $this->XMLData=array();
    $this->Defaults=array();
    $this->PathToXML=$PathToXML;
    $this->XmlLoaded=array();

    $this->FindBrowser=true; //  
    $this->FindOS=true; //   
    $this->FindEngine=true; //   
    $this->FindRobot=true; //  

    //  -    [ignore],   
    $this->StopParsing=false;
}

function ParseUA($Str='')
{
    $this->StopParsing=false;
    $this->TokenArr=array();
    $this->Comment='';
    $this->CommentArr=array();
    $this->Info=array('Browser'=>'','BrowserVersion'=>'','FullBrowserVersion'=>'',
                        'OS'=>'','OSVersion'=>'','FullOSVersion'=>'',
                        'Engine'=>'', 'EngineVersion'=>'', 'FullEngineVersion'=>'',
                        'PotentialBot'=>false,
                        'Other'=>'','OtherVersion'=>'','FullOtherVersion'=>'','OtherType'=>'',
                        'Data'=>array());
    $this->UA=$Str;

    //    ProductToken[/Version] [lang] [(comment)]
    $Reg='#([^\s/]+((?(?=\s)\s[^(\[]|[/])[^\s]+)?)(\s\[[a-zA-Z]+\])?(\s\(((?>[^()]+)|\([^)]*?\))+\))?#';
    $Res=array();
    preg_match_all($Reg,$Str,$Res);
    if (empty($Res)) return $this->Info;

    if (@$Res[1]) $this->TokenArr=$Res[1];
    if (@$Res[4]) foreach ($Res[4] as $Row) {
        $Row=str_replace("(","",str_replace(")","",$Row));
        $this->Comment.=trim($Row);
        $Arr=explode(";",trim($Row));
        foreach ($Arr as $SubRow) if (trim($SubRow)) $this->CommentArr[]=trim($SubRow);
    }
    unset($Res);

    if (preg_match('#bot|spider|crawler|indexer#i',$this->UA)) $this->Info['PotentialBot']=true;

    //      ,
    //    netscape   ,    
    if ($this->FindOS) $this->IdentifyOS();
    if ($this->FindBrowser) $this->IdentifyBrowser();
    if ($this->FindEngine) $this->IdentifyEngine();
    if ($this->FindRobot && (!$this->Info['Browser']||$this->Info['PotentialBot'])) $this->IdentifyRobot();

    if ($this->Info['Other'] && $this->Info['PotentialBot']) {
        $this->Info['Browser']='';
        $this->Info['BrowserVersion']='';
        $this->Info['FullBrowserVersion']='';
    }
    return $this->Info;
}

//////////////////////////////////////////////////////////////
//

function IdentifyBrowser()
{
    if ($this->StopParsing) return false;
    if (!$this->LoadXmlData('browser.xml')) return false;
    //     product token
    $this->FindProductInArray($this->TokenArr,'browser');

    //     ,    - mozilla,     compatible
    if (!$this->Info['Browser'] && strpos(strtolower(@$this->TokenArr[0]),"mozilla")!==false) {
        //if (trim(strtolower(@$CArr[0]))=='compatible') -   ,   compatible :(
        $this->FindProductInArray($this->CommentArr,'browser');
    }
    if ($this->StopParsing) return false;

    //   netscape  mozilla
    if (!$this->Info['Browser'] && strpos(strtolower(@$this->TokenArr[0]),"mozilla")!==false) {
        $Token=explode("/",$this->TokenArr[0]);
        //     
        if (@$Token[1]&&intval($Token[1])<5&&isset($this->XMLData['browser']['netscape'])&&$this->Comment
            &&trim(strtolower(@$this->CommentArr[0]))!='compatible') {
            $this->Info['Browser']=$this->XMLData['browser']['netscape']['name'];
            $this->Info['Data']['browser']=$this->XMLData['browser']['netscape'];
            $this->ProductVersion($Token[1],'netscape','browser');
        }
        elseif (isset($this->XMLData['browser']['mozilla'])&&@$this->CommentArr[0]&&
                    ($R=@$this->XMLData['browser']['mozilla']['reg_version'])&&
                    preg_match_all($this->RegStr($R),$this->UA,$Version)) {

                    $Version=$this->RegValue($R,$Version,1000);
                    $this->Info['Browser']=$this->XMLData['browser']['mozilla']['name'];
                    $this->Info['Data']['browser']=$this->XMLData['browser']['mozilla'];
                    $this->ProductVersion($Version,'mozilla','browser');
        }
    }

    if (!$this->Info['Browser']&&(preg_match('#http://|www\.|client#i',$this->UA)||!@$this->CommentArr[0]))
         $this->Info['PotentialBot']=true;
}

function IdentifyEngine()
{
    if ($this->StopParsing) return false;
    if (!$this->LoadXmlData('engine.xml')) return false;
    $ekey=false;
    $Version=false;
    foreach ($this->XMLData['engine'] as $k=>$Engine) {
        $Version=false;
        if (!@$Engine['reg_name'] || !preg_match($this->RegStr($Engine['reg_name']),$this->UA)) continue;
        if ( @$Engine['reg_version'] && preg_match($this->RegStr($Engine['reg_version']),$this->UA,$Version)) {
            $Version=$this->RegValue($Engine['reg_version'],$Version,1000);
        }
        if ($k!=$this->VerifyEngineDependence($k)) continue;
        $ekey=$k;
        break;
    }

    if (!$ekey) $ekey=$this->VerifyEngineDependence();
    if ($ekey) {
        $this->Info['Engine']=$this->XMLData['engine'][$ekey]['name'];
        $this->Info['Data']['engine']=$this->XMLData['engine'][$ekey];
        $this->ProductVersion($Version,$ekey,'engine');
    }
}

function VerifyEngineDependence($ekey=false)
{
    if ($ekey && !isset($this->XMLData['engine'][$ekey]['dependence'])) return $ekey;
    foreach ($this->XMLData['engine'] as $e=>$Engine) {
        if (!@$Engine['dependence']) continue;
        if ($ekey && $e!=$ekey) continue;
        if (!$ekey && (@$Engine['reg_name'] || @$Engine['reg_version'])) continue;
        $Dep=$Engine['dependence'];
        if (isset($Dep['not_browser'])&&@$this->Info['Data']['browser']['key']) foreach ($Dep['not_browser'] as $os=>$b) {
            if (strval(intval($os)) != strval($os) && $os!=@$this->Info['Data']['os']['key']) continue;
            if ($b!=@$this->Info['Data']['browser']['key']) continue;
            return false;
        }
        if (isset($Dep['not_os'])&&@$this->Info['Data']['os']['key']) foreach ($Dep['not_os'] as $b=>$os) {
            if (strval(intval($b)) != strval($b) && $b!=@$this->Info['Data']['browser']['key']) continue;
            if ($os!=@$this->Info['Data']['os']['key']) continue;
            return false;
        }
        if (isset($Dep['browser'])&&@$this->Info['Data']['browser']['key']) foreach ($Dep['browser'] as $os=>$b) {
            if (strval(intval($os)) != strval($os) && $os!=@$this->Info['Data']['os']['key']) continue;
            if ($b!=@$this->Info['Data']['browser']['key']) continue;
            return $e;
        }
        if (isset($Dep['os'])&&@$this->Info['Data']['os']['key']) foreach ($Dep['os'] as $b=>$os) {
            if (strval(intval($b)) != strval($b) && $b!=@$this->Info['Data']['browser']['key']) continue;
            if ($os!=@$this->Info['Data']['os']['key']) continue;
            return $e;
        }
    }
    return false;
}

function IdentifyOS()
{
    if ($this->StopParsing) return false;
    if (!$this->LoadXmlData('os.xml')) return false;
    $this->FindProductInArray($this->CommentArr,'os');
}

function IdentifyRobot()
{
    if ($this->StopParsing) return false;
    if (!$this->LoadXmlData('other.xml')) return false;
    $otkey=false;
    $Version=false;
    foreach ($this->XMLData['other'] as $k=>$Other) {
        $Version=false;
        if (!@$Other['reg_name'] ) $Other['reg_name']=(!@$Other['searchkey'])?
                                                                                    "#{$Other['key']}#i":"#{$Other['searchkey']}#i";
        if (!@$Other['reg_version'] && @$this->Defaults['other']['reg_version'] && !@$Other['other_noversion'])
                $Other['reg_version'] = (!@$Other['searchkey'])?
                str_replace("{KEY}",$Other['key'],$this->Defaults['other']['reg_version']):
                str_replace("{KEY}","(".$Other['searchkey'].")",$this->Defaults['other']['reg_version']);
        if ( !preg_match($this->RegStr($Other['reg_name']),$this->UA)) continue;
        if ( @$Other['reg_version'] && preg_match($this->RegStr($Other['reg_version']),$this->UA,$Version)) {
            $Version=$this->RegValue($Other['reg_version'],$Version,1000);
        }
        $otkey=$k;
        break;
    }
    if ($otkey) {
        $this->Info['Other']=$this->XMLData['other'][$otkey]['name'];
        $this->Info['OtherType']=@$this->XMLData['other'][$otkey]['type'];
        $this->Info['Data']['other']=$this->XMLData['other'][$otkey];
        $this->ProductVersion($Version,$otkey,'other');
    }
}

//////////////////////////////////////////////////
// main search function

function FindProductInArray($LookupArr=array(),$LookFor='browser')
{
    if (empty($LookupArr)) return false;
    //       ,     
    //     
    //       ,     
    for ($i=count($LookupArr)-1; $i>=0; $i--) {
        $Row=trim($LookupArr[$i]); if (!$Row) continue;
        $ProdsArr=&$this->XMLData[$LookFor];
        foreach ($ProdsArr as $Key=>$Elem) {
            if ($Key=='mozilla') continue;
            if (@$Elem['searchkey']) $a=explode("|",$Elem['searchkey']);
            else $a=array($Key);
            foreach ($a as $b) {
                $Product=false; $Version='';

                $c=false;
                if (($R=@$Elem['reg_name'])&&!($c=preg_match($Elem['reg_name'],$Row))) continue;
                elseif (!$c&&strpos(strtolower($Row),$b)!==0) continue;

                if ($p=strrpos($Row,"/")) $Product=substr($Row,0,$p);
                elseif ($p=strrpos($Row," ")) $Product=substr($Row,0,$p);
                else $Product=$Row;

                if (@$Elem['reg_skip']&&preg_match($Elem['reg_skip'],$this->UA)) continue;
                if (@$Elem['reg_ignore']&&preg_match($Elem['reg_ignore'],$this->UA)) {$this->StopParsing=true;return false;}
                if (@$Elem['reg_version']) {
                    if (preg_match_all($this->RegStr($Elem['reg_version']),$this->UA,$Version))
                        $Version=$this->RegValue($Elem['reg_version'],$Version,1000);
                    else $Version=false;
                }
                if (!$Version) $Version=trim(str_replace("/","",str_replace($Product,"",$Row)));

                if ($LookFor=='browser') $this->Info['Browser']=$Elem['name'];
                if ($LookFor=='os') $this->Info['OS']=$Elem['name'];
                $this->Info['Data'][$LookFor]=$Elem;
                $this->ProductVersion($Version,$Key,$LookFor);
                break(3);
            }
        }
    }
    return false;
}

//////////////////////////////////////////////////////
// versions

function ProductVersion($FullVersion='',$Prod='',$LookFor='browser')
{
    $Elem=&$this->XMLData[$LookFor][$Prod];
    $HasMatrix=isset($Elem['version_matrix']);
    if (!$FullVersion && !$HasMatrix) return false;
    if ($HasMatrix&&@$Elem['version_matrix_mode']=='range')
        $Version=$this->GetVersionFromRange($Elem['version_matrix'],$FullVersion);
    elseif (@$Elem[$LookFor.'_noversion']) $Version=false;
    elseif ($HasMatrix&&!isset($Elem['version_matrix'][$FullVersion]) && !@$Elem['reg_version']) $Version=false;
    elseif ($HasMatrix&&!isset($Elem['version_matrix'][$FullVersion]) && @$Elem['reg_version']) $Version=$FullVersion;
    elseif ($HasMatrix&&isset($Elem['version_matrix'][$FullVersion])) $Version=$Elem['version_matrix'][$FullVersion];
    elseif (!$HasMatrix) $Version=$FullVersion;

    if (($R=@$Elem['reg_versionformat'])) $Reg=$R;
    else $Reg=@$this->Defaults[$LookFor]['versionformat'];
    if (@$Reg) {
        preg_match($this->RegStr($Reg),$Version,$Res);
        $Version=$this->RegValue($Reg,$Res,0);
    }

    if ($LookFor=='browser') { $this->Info['FullBrowserVersion']=$FullVersion; $this->Info['BrowserVersion']=$Version; }
    if ($LookFor=='os') { $this->Info['FullOSVersion']=$FullVersion; $this->Info['OSVersion']=$Version; }
    if ($LookFor=='engine') { $this->Info['FullEngineVersion']=$FullVersion; $this->Info['EngineVersion']=$Version;}
    if ($LookFor=='other') { $this->Info['FullOtherVersion']=$FullVersion; $this->Info['OtherVersion']=$Version;}
}

function GetVersionFromRange(&$Matrix,$FullVersion)
{
    foreach ($Matrix as $k=>$Version) {
        if (strpos($k,'-')===false) continue;
        $Arr=explode('-',$k);
        if (function_exists('version_compare')) {
            if (version_compare($Arr[0],$FullVersion,'<=') && version_compare($Arr[1],$FullVersion,'>=')) return $Version;
        }
        elseif (intval($Arr[0])<=intval($FullVersion) && intval($Arr[1])>=intval($FullVersion)) return $Version;
    }
    return false;
}


////////////////////////////////////////////////
// regular expressions

function RegValue($Reg='',$ResArr=array(),$Default=1000)
{
    $ValuePlace=$Default;
    $Delimiter="/";
    if (preg_match('/\d/',substr($Reg,0,1))) {
        preg_match('/[^\d]/',$Reg,$Delimiter);
        $Delimiter=@$Delimiter[0];
        $Arr=explode($Delimiter,$Reg);
        $Arr=array_slice($Arr,0,count($Arr)-2);
        $ValuePlace=implode($Delimiter,$Arr);
    }
    if ($ValuePlace==1000) {
        while (is_array($ResArr)&&!empty($ResArr)) $ResArr=$ResArr[count($ResArr)-1];
        return (empty($ResArr))?false:trim($ResArr);
    }
    if (strval(intval($ValuePlace))==strval($ValuePlace)) {
        while (is_array(@$ResArr[$ValuePlace])) $ResArr=$ResArr[$ValuePlace];
        return trim(@$ResArr[$ValuePlace]);
    }
    else {
        $Arr=explode($Delimiter,$ValuePlace);
        foreach ($Arr as $Place) $ResArr=@$ResArr[$Place];
        return trim($ResArr);
    }
}

//       (.RegValue())
function RegStr($Reg='')
{
    if (preg_match('/\d/',substr($Reg,0,1))) {
        preg_match('/[^\d]/',$Reg,$Delimiter);
        $Delimiter=@$Delimiter[0];
        $Arr=explode($Delimiter,$Reg);
        $Arr=array_slice($Arr,count($Arr)-2);
        $Reg=$Delimiter.implode($Delimiter,$Arr);
    }
    return $Reg;
}

///////////////////////////////////////////////////////
// Xml parsing

function LoadXmlData($Library=false)
{
    if (!$Library) return false;
    if (isset($this->XmlLoaded[$Library])) return true;
    $f=@fopen($this->PathToXML.$Library,'r');
    $XmlData=@fread($f,filesize($this->PathToXML.$Library));
    @fclose($f);
    if ($XmlData) {$this->ParseXmlData($XmlData); return $this->XmlLoaded[$Library]=true;}
    return false;
}

function ParseXmlData($XML)
{
    $Struct=array();
    $p=xml_parser_create();
    xml_parser_set_option($p,XML_OPTION_CASE_FOLDING,0);
    xml_parser_set_option($p,XML_OPTION_SKIP_WHITE,1);
    xml_parse_into_struct($p,$XML,$Struct);
    xml_parser_free($p);
    if (empty($Struct)) return false;
    $CurrentElement=array();
    $LastLevelKey='';
    foreach ($Struct as $Row) {
        if ($Row['level']==2) {
            if (@$Row['attributes']) foreach ($Row['attributes'] as $k=>$v) {
                $this->Defaults[str_replace('data','',$Row['tag'])][$k]=$v;
            }
            continue;
        }

        if ($Row['level']==3 && $Row['type']=='open') {
            $CurrentElement['type']=$Row['tag'];
            if (@$Row['attributes']) foreach ($Row['attributes'] as $a=>$v) $CurrentElement[$Row['tag']."_$a"]=trim($v);
        }
        if ($Row['level']==3 && $Row['type']=='close') {
            $this->ParseXmlElement($CurrentElement); $CurrentElement=array(); continue;}
        if ($Row['type']=='close') continue;
        if ($Row['level']==4) {
            $LastLevelKey=$Row['tag'];
            $CurrentElement[$Row['tag']]=trim(@$Row['value']);
            if (@$Row['attributes']) foreach ($Row['attributes'] as $a=>$v) $CurrentElement[$Row['tag']."_$a"]=trim($v);
        }
        if ($Row['level']==5) {
            $CurrentElement[$LastLevelKey][$Row['tag']]=trim($Row['value']);
            if (@$Row['attributes']) foreach ($Row['attributes'] as $a=>$v)
                $CurrentElement[$LastLevelKey][$Row['tag']."_$a"]=trim($v);
        }
    }
}

function ParseXmlElement($Elem=array())
{
    if (empty($Elem)) return false;
    if (@$Elem['version_matrix']) {
        $Arr=explode("|",$Elem['version_matrix']);
        $Elem['version_matrix']=array();
        foreach ($Arr as $Str) {
            $Arr2=explode("=",$Str);
            $Elem['version_matrix'][trim($Arr2[0])]=trim($Arr2[1]);
        }
    }
    if (@$Elem['dependence']) {
        foreach ($Elem['dependence'] as $k=>$Str) {
            $Arr=explode("|",$Str);
            $Elem['dependence'][$k]=array();
            foreach ($Arr as $i=>$Str2) {
                $Arr2=explode("=",$Str2);
                if (count($Arr2)>1) $Elem['dependence'][$k][trim($Arr2[0])]=trim($Arr2[1]);
                else $Elem['dependence'][$k][$i]=trim($Arr2[0]);
            }
        }
    }
    $this->XMLData[$Elem['type']][$Elem['key']]=$Elem;
}

}
?>