/* 'help window', 'visitor card'
 * 
 * public interface:
 * 
 * show(URL,beforeCallback,afterCallback)
 * close(imidiately,beforeCallback,afterCallback)
 * setPosition(top, left)
 * setSize(width, height)
 * setRelativePosition(obj,leftOffset,topOffset)
 * clearTimeout()
 * 
 * (c) stuffed guys
 * written by johann kuindji
 * jQuery and loadURL are required
 */

function ajaxDiv(options) {
    if (!options) options = {}
    // id   (    )
    this.outerDiv=options.outerDiv||false
    // id ,     
    this.wrapperDiv=options.wrapperDiv||false
    // id ,  ,   
    this.loadingDiv=options.loadingDiv||false
    //    
    this.initialURL=options.initialContentURL||false

    //    
    //      
    this.initialLoading=options.initialLoading||false
    //     
    this.initialLoadingStop=options.initialLoadingStop||false
    //    
    this.innerLoading=options.innerLoading||false
    //    
    this.innerLoadingStop=options.innerLoadingStop||false
    //   
    this.openTime=typeof(options.openTime)!='undefined'?options.openTime:500
    //    
    this.closeTime=typeof(options.closeTime)!='undefined'?options.closeTime:500
    //   mouseout,  
    this.disableMouseout=options.disableMouseout||false

    this.currentAjaxDivURL=''
    this.obj=$('#'+this.outerDiv)
    this.wrapper=false
    this.loadingObj=false

    this._ajaxDivTimeout=false
    this._ajaxDivDontClose=false
    this._working=false
    this._URL=false

    this._beforeShowCallback=false
    this._afterShowCallback=false
    this._beforeCloseCallback=false
    this._afterCloseCallback=false
    
    this._opened=false

    ajaxDivExtend(this)
}

function ajaxDivExtend(o) {

    //    
    o.clearTimeout = function () {
        if (o._ajaxDivTimeout) window.clearTimeout(o._ajaxDivTimeout)
        o._ajaxDivTimeout=false
    }

    //    
    //  wrapperDiv    
    o.load = function(URL,callback) {
        if (URL) o._URL=URL
        if (o.currentAjaxDivURL==o._URL) return (o._working = false)
        if (!o.wrapperDiv) return false
        if (callback) o._afterShowCallback=callback
        o.currentAjaxDivURL=o._URL
        o._working=true
        loadURL(o.wrapperDiv,o._URL,o.loading,o.loadingStop)
    }

    //           load()
    o._open = function() {
        if (o.initialLoadingStop) o.initialLoadingStop()
        if (o.wrapperDiv) o.wrapper=$('#'+o.wrapperDiv)
        if (o.loadingDiv) o.loadingObj=$('#'+o.loadingDiv)
        if (o.wrapper && o.currentAjaxDivURL!=o._URL && 
            o.wrapperDiv != o.outerDiv && !o._opened) o.wrapper.html('')
        if (o._opened) o.load()
        else o.obj.slideDown('normal',function() { o._opened=true; o.load() })
    }

    //         _open()
    o._show = function() {
        o.clearTimeout()
        o._working=true
        if (o._beforeShowCallback) o._beforeShowCallback()
        if ((!jQuery.trim(o.obj.html())||o.outerDiv==o.wrapperDiv) && 
            o.initialURL && !o._opened) 
                return loadURL(o.outerDiv,o.initialURL,o.initialLoading,o._open)
        o._open()
    }

    //    
    o._close = function() {
        if (o._working) return false
        if (o._ajaxDivDontClose) return false
        if (o._beforeCloseCallback) o._beforeCloseCallback()
        o._working=true
        if (o._opened) o.obj.slideUp('normal',function(){
            o._working=false
            o._opened=false
            if (o._afterCloseCallback) o._afterCloseCallback()
        })
        else if (o._afterCloseCallback) o._afterCloseCallback()
    }

    //         
    //          
    //   _show()
    o.show = function(URL,beforeShowCallback,afterShowCallback) {
        if (!URL) return false
        if (o._working) return false
        o.clearTimeout()
        o._URL=URL;
        if (beforeShowCallback) this._beforeShowCallback=beforeShowCallback
        if (afterShowCallback) this._afterShowCallback=afterShowCallback
        if (!o.openTime) return o._show()
        o._ajaxDivTimeout = window.setTimeout(o._show,o.openTime)
    }

    //     
    o.close = function(imidiately,beforeCloseCallback,afterCloseCallback) {
        o._beforeCloseCallback = beforeCloseCallback
        o._afterCloseCallback = afterCloseCallback
        o.clearTimeout()
        if (o._working) return false
        if (o._ajaxDivDontClose) {
            o._ajaxDivDontClose = false
            return false
        }
        if (o.closeTime && !imidiately) 
            o._ajaxDivTimeout = window.setTimeout(o._close,o.closeTime)
        else o._close()
    }

    o.loading = function() {
        if (o.innerLoading) return o.innerLoading()
        if (o.loadingDiv) o.loadingObj.show()
    }

    o.loadingStop = function() {
        if (o.innerLoadingStop) o.innerLoadingStop()
        else if (o.loadingDiv) o.loadingObj.hide()
        if ($.browser.opera) o.wrapper.css('z-index','999')
        o._working=false
        if (o._afterShowCallback) o._afterShowCallback()
    }

    o.setPosition = function(top,left) {
        o.obj.css('left',parseInt(left)+'px').css('top',parseInt(top)+'px')
    }

    o.setSize = function(width,height) {
        o.obj.css('width',parseInt(width)+'px').css('height',parseInt(height)+'px')
    }

    o.setRelativePosition = function (object,offsetTop,offsetLeft) {
        if ( (position = $(object).offset()) == false) return false
        o.setPosition(position.top+offsetTop, position.left+offsetLeft)
    }

    o.setEventRelativePosition = function (ev, offsetTop, offsetLeft) {
        var eventData = jQuery.eventData(ev)
        if (!eventData.target) return false
        o.setRelativePosition(eventData.target,offsetTop,offsetLeft)
    }

    if (!o.disableMouseout) {
        o.obj.bind('mouseover',function(){ o._ajaxDivDontClose=true })
        o.obj.bind('mouseout',o.close)
    }
}
