<?
$Lang['CodeGen']="Tracking code";



$Lang['CodeType1']="Javascript code";
$Lang['CodeType2']="Javascript (document.write)";
$Lang['CodeType3']="HTML code";
$Lang['CodeType4']="PHP code";
$Lang['CodeType5']="ActionScript 2 (Flash)";

$Lang['ForSite']="Track visitors";
$Lang['ForShop']="Track sales";
$Lang['ForAction']="Track action";

$Lang['Generate']="Generate";
$Lang['Code']="Code";

$Lang['SSL']="SSL";
$Lang['NoActionForSite']="No actions that are caught using tracking code were configured for the selected site.";

$Lang['TestItemName']="product";
$Lang['TestItemCnt']="1";
$Lang['TestItemValue']="10";

$Lang['OnEvent']="Catch action with a Javascript function call";
$Lang['CatchActionExample']="// Usage example:";
$Lang['FollowingCode']="/* Use the following code in the objects or functions to call the tracking method. */";

//////////////////////////////////////////////////////////////////////

$Lang['CodeHelpJs']=" You should place the code inside the &lt;BODY&gt; of the 
page. Generally, the higher you place the code on the page, the more accurate 
statistics you get.<br><br>

You can optionally use a text-based id of the site if it is specified for a
particular site. For this, use \"var nsSiteTextId='text_id'\" instead of
\"var nsSiteId=numerical_id\" inside the tracking code. In the &lt;noscript&gt;
part of the code you should use \"&stext=text_id\" parameter instead of 
\"&st=numerical_id\".";

$Lang['CodeHelpPhp']="<br><br>Please note, that the PHP tracking code should be 
placed inside of a PHP page BEFORE any content was sent to the browser.<br><br>

You can optionally use a text-based id of the site if it is specified for a
particular site. To do this, please specify the text id as the 4th parameter
in the nsTrack function.";


$Lang['CodeHelpHtml']=" You should place the code inside the &lt;BODY&gt; of the 
page. Generally, the higher you place the code on the page, the more accurate 
statistics you get.<br><br>

This type of tracking code is quite limited in its capabilities (for example,
it is not able to track referrers) and you should consider it only for situations
when it is not possible to use Javascript or PHP tracking.<br><br>

You can optionally use a text-based id of the site if it is specified for a
particular site. For this, use should use \"&stext=text_id\" parameter instead 
of \"&st=numerical_id\" inside the tracking code.";

$Lang['CodeHelpAs']=" You should place the code below in one of the first
frames of the timeline so that it will be accessible to all objects in the 
project. Also, you need to add a special ActionScript class in your project
'<b>com.stuffedguys.tracker.Tracker</b>' (<a href='".PATH."/store/as2.zip'>tracker/store/as2.zip</a>).<br><br>

<b>crossdomain.xml:</b><br>

In order for the tracker to get the tracking request from your flash movie,
you need to place 'crossdomain.xml' file (<a href='".PATH."/store/crossdomain.xml'>tracker/store/crossdomain.xml</a>)
in the root folder of the domain where you have the tracker installed. Inside the
file you need to specify all the domains from which your Flash movie should
be able to make a call to the tracker.<br>
";


//////////////////////////////////////////////////////////////////////



$Lang['CodeHelpVis']="You should place the code presented below inside of all the pages of 
the site. ";

$Lang['CodeHelpAction']="You should place the code presented below inside the 
page of your site which if requested by a visitor should trigger an action.";

$Lang['CodeHelpSale']="You should place the code presented below inside a
\"thank you\" page, which is displayed at the last step of the ordering process.";



//////////////////////////////////////////////////////////////////////


$Lang['CodeCommentAs'] = "How to call the tracking functions:<br>
nsTracker.track('/some_address'); // track a page view (visitor step)<br>
nsTracker.trackAction('/action_page', actionId, actionItem); // track an action<br>
nsTracker.trackSale('/sale_page', products, orderId, orderInfo, orderCost, tags); // track a sale<br><br>

The first parameter of all functions is the location of the page that should
be logged by the tracker. You can specify any location, the only restriction 
is that the location should always be present in the function call &mdash; 
otherwise nothing will be tracked.<br><br>

You can specify the location of the page as a complete URL (for example, 'http://yoursite.com/some_address/some_page.html')
or as a path (for example, '/some_address/some_page.html'). If you will use
the latter method you need to make sure that stSiteHost variable is not
empty in the tracking code, otherwise nothing will be tracked.<br><br>

Along with the page location you can also pass the page title by specifying
both the location and the title in an object and passing this object as the 
first parameter of the funciton call. For example:<br>
nsTracker.track({Addr: '/some_address', Title: 'Page title'});<br><br>

Additional parameters:<br>
nsTracker.visitorName:String - visitor name<br>
nsTracker.tags:Array - visitor tags<br>
nsTracker.overwriteTags:Boolean - asks to replace the current visitor tags with the tags specified in nsTracker.tags<br>
nsTracker.presetIP:String - visitor IP<br>
nsTracker.presetID:String - visitor ID<br>
nsTracker.charset:String - indicates in which charset an optional page title is specified<br><br>";


$Lang['SaleCommentJs']="Please note, that the code above only tracks an event of the sale, which is
enough to calculate conversion ratio. However:<br><br>

<ol>
<li>If you also want to track the <b>total value of the sale</b>, you would need 
to use the nsCost variable in the tracking code like this:  

<blockquote style=\"color: #777;\">
var nsCost='total_value';
</blockquote>

and replace \"total_value\" with an actual value of the sale.<br><br></li>

<li>If you want to additionally track information about <b>particular products</b> 
that were sold, you would need to use the nsOrderItems variable in the tracking 
code like this: 

<blockquote style=\"color: #777;\">
nsOrderItems.push('{{product_name}}{{value}}{{quantity}}'); 
</blockquote>

and replace \"product_name\" with an actual name of the product, \"value\"
with an actual value of the product and \"quantity\" with an actual 
quantity that was sold. You can use the nsOrderItems variable in the same way
several times to specify several different products that were sold.<br><br></li>

<li>You can also track an <b>id of the order</b> from your own shopping system. 
For this you would need to use the nsOrderId variable in the tracking code like
this: 

<blockquote style=\"color: #777;\"> 
var nsOrderId='your_order_id';
</blockquote>

and replace \"your_order_id\" with an actual id of the order in your shopping
system. The maximum length of the id is 64 symbols and it can contain any 
alpha-numerical characters.<br><br></li>

<li>Along with the sale, you can also log any <b>additional information</b> that
would be visible in the Sales log. For this you would need to use the nsOrderInfo
variable in the tracking code like this: 

<blockquote style=\"color: #777;\"> 
var nsOrderInfo='some_data';
</blockquote>

and replace \"some_data\" with any data that you want to store along with the 
sale.</li>

</ol>";

$Lang['SaleCommentPhp']="Please note, that the code above only tracks an event of the sale, which is
enough to calculate conversion ratio. However:<br><br>

<ol>
<li>If you also want to track the <b>total value of the sale</b>, you would need 
to use the \$nsSTcost variable in the tracking code like this:  

<blockquote style=\"color: #777;\">
\$nsSTcost='total_value';
</blockquote>

and replace \"total_value\" with an actual value of the sale.<br><br></li>

<li>If you want to additionally track information about <b>particular products</b> 
that were sold, you would need to use the \$nsSTItems variable in the tracking 
code like this: 

<blockquote style=\"color: #777;\">
\$nsSTItems[0]['Name']='product_name';<br>
\$nsSTItems[0]['Value']='value';<br>
\$nsSTItems[0]['Cnt']='quantity'; 
</blockquote>

and replace \"product_name\" with an actual name of the product, \"value\"
with an actual value of the product and \"quantity\" with an actual 
quantity that was sold. You can use the nsOrderItems variable in the same way
several times to specify several different products that were sold.<br><br></li>

<li>You can also track an <b>id of the order</b> from your own shopping system. 
For this you would need to use the \$nsSToid variable in the tracking code like
this: 

<blockquote style=\"color: #777;\"> 
\$nsSToid='your_order_id';
</blockquote>

and replace \"your_order_id\" with an actual id of the order in your shopping
system. The maximum length of the id is 64 symbols and it can contain any 
alpha-numerical characters.<br><br></li>

<li>Along with the sale, you can also log any <b>additional information</b> that
would be visible in the Sales log. For this you would need to use the \$nsSToinfo
variable in the tracking code like this: 

<blockquote style=\"color: #777;\"> 
\$nsSToinfo='some_data';
</blockquote>

and replace \"some_data\" with any data that you want to store along with the 
sale.</li>

</ol>";

$Lang['SaleCommentHtml']="Please note, that the code above only tracks an event of the sale, which is
enough to calculate conversion ratio. However:<br><br>

<ol>
<li>If you also want to track the <b>total value of the sale</b>, you would need 
to add the following parameter to the image source URL in the tracking code above:<br> 

<blockquote style=\"color: #777;\">
&cs=total_value
</blockquote>

and replace \"total_value\" with an actual value of the sale.<br><br></li>

<li>If you want to additionally track information about <b>particular products</b> 
that were sold, you would need to add the following parameter to the image 
source URL in the tracking code above:<br>

<blockquote style=\"color: #777;\"> 
&itm[]={{product_name}}{{value}}{{quantity}}
</blockquote>

and replace \"product_name\" with an actual name of the product, \"value\"
with an actual value of the product and \"quantity\" with an actual 
quantity that was sold. You can use this \"itm[]\" parameter several times 
to specify several different products that were sold.<br><br></li>

<li>You can also track an <b>id of the order</b> from your own shopping system. For this you
would need to add the following parameter to the image source URL in the tracking 
code above:<br>

<blockquote style=\"color: #777;\"> 
&oid=your_order_id
</blockquote>

and replace \"your_order_id\" with an actual id of the order in your shopping
system. The maximum length of the id is 64 symbols and it can contain any 
alpha-numerical characters.<br><br></li>

<li>Along with the sale, you can also log any <b>additional information</b> that
would be visible in the Sales log. For this you would need to add the following 
parameter to the image source URL in the tracking code above:<br>

<blockquote style=\"color: #777;\"> 
&oinfo=some_data
</blockquote>

and replace \"some_data\" with any data that you want to store along with the 
sale.</li>

</ol>";


$Lang['SaleCommentAs']="<br><br><b>Track a sale:</b><br>

Example of the code to track a sale:<br>
var products:Array = [{name:'product name 1', cnt:1, value: 100}, {name:'product name 2', cnt:1, value: 50}]<br>
var tags:Array = ['tag1', 'tag2']<br>
var orderId:String = '' <br>
var orderInfo:String = ''<br>
var orderCost:String = ''<br>
nsTracker.trackSale('/sale_page', products, orderId, orderInfo, orderCost, tags); <br>
";
$Lang['ActionCommentAs']="<br><br><b>Track an action:</b><br>

Example of the code to track an action:<br>
var actionId = {ACTION_ID};<br>
var actionItem = '';<br>
nsTracker.trackAction('/action_page', actionId, actionItem); <br>
";

?>