<?
require_once SELF."/class/cache_v2.class.php";
require_once SELF."/class/report_parent_v2.class.php";
require_once SELF."/class/constructor.class.php";

define('NO_SESSION_DATES', true);

$OnlinePeriod=$Settings['All']->ONLINE_PERIOD;
if (!$OnlinePeriod || $OnlinePeriod < 0) $OnlinePeriod=600;
$Stamp=gmdate("Y-m-d H:i:s");
$Query = "
    SELECT 
        S_LOG.SITE_ID,
        COUNT(DISTINCT S_LOG.VISITOR_ID) AS CNT
        FROM ?_{$CpId}_stat_log S_LOG
        WHERE S_LOG.STAMP BETWEEN DATE_ADD('$Stamp', INTERVAL -$OnlinePeriod SECOND) AND '$Stamp'
        GROUP BY S_LOG.SITE_ID
";
$Sql = new Query($Query);
$OnlineArr=array();
while ($Row=$Sql->Row()) {
    $OnlineArr[$Row->SITE_ID]=$Row->CNT;
}

UserColumns(); // ,     
$Today=UserDate();
$RealTime=false;

$RData = new ReportData();
$RData->EnableSorting=false;
$RData->ShowNextStep=false;
$RData->ShowSimpleName=true;
$RData->EnableSubValues=false;
$RData->CssIncluded = true;

$RData->AddColumn("Name",$Lang['Site']);

if ($nsUser->Columns->HITS) {  
    $RData->AddColumn("CntClick",$Lang['RHeaderPV'],"CNT");
    $RData->AddColumn("UniClick",$Lang['RHeaderUni'],"UNI","Visitor");
    if ($nsUser->Columns->VISITS) $RData->AddColumn("Visits",$Lang['RHeaderVisits'],"VISITS","Visitor");
    if ($nsUser->Columns->NEWRET) $RData->AddColumn("New",$Lang['RHeaderNew'],"NEW","Visitor");
    if ($nsUser->Columns->NEWRET) $RData->AddColumn("Returning",$Lang['RHeaderReturn'],"RETURNING","Visitor");    
}
if ($nsUser->Columns->CLICKS) {  
    $RData->AddColumn("CntCamp",$Lang['RHeaderTotal'],"CNT","Camp");
    $RData->AddColumn("UniCamp",$Lang['RHeaderUni'],"UNI","Camp");
}
if ($nsUser->Columns->SALES) {  
    $RData->AddColumn("CntSale",$Lang['RHeaderTotal'],"SALECNT","Sale");
    $RData->AddColumn("UniSale",$Lang['RHeaderUni'],"SALEUNI","Sale");
}
if ($nsUser->Columns->ACTIONS) {  
    $RData->AddColumn("CntAction",$Lang['RHeaderTotal'],"ACTIONCNT","Action");
    $RData->AddColumn("UniAction",$Lang['RHeaderUni'],"ACTIONUNI","Action");
}

$R = new Constructor($CpId, 'NATURAL');
$R->CacheAgeLimit=60;
$R->CountIfNoCache = true;
$R->ViewDate=$Today;
$R->NoRef=true;
$R->NewVsRet = true;
$R->SessVisits = true;
$R->SelectArr[]="TS.ID";
$R->SelectArr[]="TS.HOST AS NAME";
$R->JoinArr[]="INNER JOIN ?_site TS ON TS.ID=S_LOG.SITE_ID";
$R->GroupArr[]="TS.ID";
$R->GrpFld="ID";
$R->GrpName="NAME";
$R->OrderArr[]="TS.HOST ASC";
$R->QueryParams=array("GroupBy"=>'Site', "DynamicPeriod"=>"0-d-0");

//$R->EmailMode='CUSTOM';
$R->Calculate();

if ($nsUser->Columns->CLICKS) {
    $R2 = new Constructor($CpId, 'PAID');
    $R2->CacheAgeLimit=60;
    $R2->CountIfNoCache = true;
    $R2->ViewDate=$Today;
    $R2->NoRef=true;
    $R2->DisableAll();
    $R2->_GetVisits = true;
    $R2->SelectArr[]="TS.ID";
    $R2->SelectArr[]="TS.HOST AS NAME";
    $R2->JoinArr[]="INNER JOIN ?_site TS ON TS.ID=S_LOG.SITE_ID";
    $R2->GroupArr[]="TS.ID";
    $R2->GrpFld="ID";
    $R2->GrpName="NAME";
    $R2->OrderArr[]="TS.HOST ASC";
    $R2->QueryParams=array("GroupBy"=>'Site', "DynamicPeriod"=>"0-d-0");
    $R2->Calculate();
}

if ($R->TakenFromCache) {
    $RData->BottomCaption .= $Lang['CacheUpdated'].' '._date($R->CacheStamp,'datetime');
    if (@$R->CacheTZ)  $RData->BottomCaption .= " ".str_replace("{TZ}", ($R->CacheTZ>0?"+":"").$R->CacheTZ, $Lang['CacheTimezone']);
}

$SiteList=array();
$Query = "SELECT  TS.* FROM ?_site TS WHERE TS.COMPANY_ID=? ORDER BY TS.HOST ASC";
$Sql = new Query($Query,false,$CpId);
while ($Row=$Sql->Row()) {
    $StatArr = !isset($R->StatArr[$Row->ID]) ? Constructor::StatRow() : $R->StatArr[$Row->ID];  
    $StatArr['Name'] = $Row->HOST;
    $StatArr['Online']=$R->TakenFromCache?0 : V($OnlineArr[$Row->ID],0);
    if (!$R->TakenFromCache) $RealTime=true;
    if (@$R2 && @$R2->StatArr[$Row->ID]) {
        $StatArr['CntCamp']=V($R2->StatArr[$Row->ID]['CntClick'], 0);
        $StatArr['UniCamp']=V($R2->StatArr[$Row->ID]['UniClick'], 0);
        $StatArr['Camp']=V($R2->StatArr[$Row->ID]['Camp'], 0);        
    }
    else $StatArr['CntCamp'] = $StatArr['UniCamp'] = $StatArr['Camp'] = 0;

    $StatArr['Link_Name']=getURL("visitor_path", "SiteId={$Row->ID}&CpId=$CpId", "report");
    $StatArr['Link_Online']=getURL("visitor_path", "SiteId={$Row->ID}&CpId=$CpId&OnlineOnly=1", "report");
    $StatArr['Link_CntClick']=getURL("natural_constructor", "CpId=$CpId&WhereArr[0][Mode]=Site&WhereArr[0][Id]={$Row->ID}&WhereArr[0][OrderBy]=CNT&WhereArr[0][OrderTo]=DESC&GroupBy=Date&", "report");
    $StatArr['Link_CntAction']=getURL("natural_constructor", "CpId=$CpId&WhereArr[0][Mode]=Site&WhereArr[0][Id]={$Row->ID}&WhereArr[0][OrderBy]=CNT&WhereArr[0][OrderTo]=DESC&GroupBy=Action&ViewDate=$Today", "report");
    $StatArr['Link_CntCamp']=getURL("paid_constructor", "CpId=$CpId&WhereArr[0][Mode]=Site&WhereArr[0][Id]={$Row->ID}&WhereArr[0][OrderBy]=CNT&WhereArr[0][OrderTo]=DESC&GroupBy=Camp&ViewDate=$Today", "report");
    //$StatArr['Report']=&$R;
    
    $RData->AddRow($StatArr);
}

if ($RealTime)  $RData->AddColumn("Online",$Lang['Online']);
$ShowOnline=true;
$RData->Id = 'dashtoday';
$RData->ShowSubSum = true;
$RData->MakeSum();
$RData->TopCaption = $Lang['StatPeriod'];
$RData->RefreshLink = 'javascript:;';
$RData->RefreshJs = "loadDashReport('SiteStat', '".getURL('client_page', 'Mode=sttoday&ax=1')."', '$RData->Id');";
$RData->CheckExport();
//$RData->PrepareButtons();
//Dump($RData->CaptionButtonsLeft);
$RData->HtmlDump();

if (defined('DEBUG') && @$_REQUEST['debug']) include SELF.'/template/_console.inc.php';
?>