<?
function CheckCpuLoad($CpId=false, $NoComment=NO_CRON_COMMENTS)
{
    global $Db, $Settings, $SetSleepMessageFunc;
    if (!defined('CRON_MODE')) return 0;
    $Cpu=GetCpuLoad(true);
    if ($Cpu==-1) return false;
    if (!$Settings['All']->CRON_MAX_CPU) return false;
    $i=0;
    while ( (double) $Cpu>= (double) $Settings['All']->CRON_MAX_CPU) {
        if ($i>=100) {
            FinishCronTask();
            exit;
        }
        if ($SetSleepMessageFunc) $SetSleepMessageFunc($CpId,$Cpu);
        global $CurrentTaskId;
        $Query = "UPDATE ?_cron_log SET STAMP = DATE_ADD(STAMP, INTERVAL 10 SECOND) WHERE ID=?";
        //$Db->Query($Query, $CurrentTaskId);
        sleep(10);
        $Cpu=GetCpuLoad(true,$NoComment);
        $i++;
    }
    return $Cpu;
}


function StartCronTask($Task)
{
    global $Db;
    $Stamp=gmdate("Y-m-d H:i:s", time());
    $Query = "INSERT INTO ?_cron_log (STAMP,FINISHED,TASK, TO_STOP) VALUES (?,?,?,NULL)";
    $Db->Query($Query,$Stamp,'0',$Task);
    return $Db->LastInsertId;
}

function FinishCronTask()
{    
    global $Db, $CurrentTaskId, $CronStartTime, $AddFinishFunc;    
    if (!$CurrentTaskId || !defined('CRON_MODE')) return false;
    $RecordLimit=100;
    $LimitStamp=false;
    if (!$CurrentTaskId) return false;
    $CronEndTime=$Db->GetMicrotime();
    $CronRunTime=$CronEndTime-$CronStartTime;   
    $Stamp=gmdate("Y-m-d H:i:s", time()); 
    $Query = "UPDATE ?_cron_log SET FINISHED='1', RUN_TIME=? WHERE ID=?";
    $Db->Query($Query, $CronRunTime, $CurrentTaskId);
    
    $Query = "DELETE FROM ?_cron_log WHERE STAMP < DATE_ADD('$Stamp', INTERVAL -10 DAY) ";
    $Db->Query($Query);
    
    if ($AddFinishFunc) $AddFinishFunc();
}

function IsCronTaskFinished() {
    global $Db, $CurrentTaskId;
    if (!$CurrentTaskId) return false;
    $Query = "SELECT TO_STOP FROM ?_cron_log WHERE ID=?";
    if ($Db->ReturnValue($Query, $CurrentTaskId)) { FinishCronTask(); return true; }
    return false;
}

function GetErrText($NoComment=NO_CRON_COMMENTS)
{
    if ($NoComment) return false;
    global $Logs;
    $Err="";
    if (!V($_SESSION['__Errors'])) return;
    foreach ($_SESSION['__Errors'] as $txt) {
        $Err.="\n\n".$txt;
    }
    return $Err;
}

function DisplayErrors($NoComment=NO_CRON_COMMENTS)
{
    if ($NoComment) return false;
    global $Logs;
    echo "\n";
    if (!V($_SESSION['__Errors'])) return;
    foreach ($_SESSION['__Errors'] as $txt) {
        echo strip_tags($txt)."\n\n";
    }
    echo "\n";
}

function CheckSkipTime($Str=false)
{
    if (!$Str) return false;
    $d=date("j"); $Y=date("Y"); $n=date("n");
    $CStamp=time();
    $Periods=explode(";",$Str);
    if (empty($Periods)) return false;
    foreach ($Periods as $Period) {
        if(!trim($Period)) continue;
        $Stamps=explode("-",trim($Period));
        $Start=explode(":",$Stamps[0]);
        $End=explode(":",$Stamps[1]);
        if ($CStamp>=mktime(intval($Start[0]),intval($Start[1]),0,$n,$d,$Y) &&
            $CStamp<=mktime(intval($End[0]),intval($End[1]),0,$n,$d,$Y)) return true;
    }
    return false;
}
?>