<?

function CronDeleteStat($NoComment=NO_CRON_COMMENTS,$Filter=array())
{
    //if (!defined("CRON_MODE")) return false;
    $AjaxMode=!defined("CRON_MODE");
    if ($AjaxMode) $NoComment=true;

    global $Db, $Settings;
    if (!$Settings['All']->DELETE_ENABLE || !$Settings['All']->DELETE_NEXT_DATE) {
        if (!$AjaxMode) return false;
    }
    $Arr=explode("|",$Settings['All']->DELETE_RUN_PERIOD);
    $TZ=V($Arr[3],0);
    $GmTime=gmdate("Y-m-d H:i:s", time());
    $Query = "SELECT IF(DATE_ADD(?, INTERVAL '".SqlTZ($TZ)."' HOUR_MINUTE) < ?, 1, 0)";
    $Check=$Db->ReturnValue($Query, $Settings['All']->DELETE_NEXT_DATE, $GmTime);
    if (!$Check && !$Settings['All']->DELETE_RUN_NOW && !$AjaxMode) {
        return false;
    }

    global $SetSleepMessageFunc;
    $SetSleepMessageFunc="SetDeleteSleepMessage";

    $CpArr=array(); $ClientNames=array();
    $MinDeleteDate=false;
    $Query = "SELECT C.ID, C.NAME FROM ?_client C";
    $Sql = new Query($Query);
    $SelectArr=array(); $FromArr=array(); $SelectStr=""; $FromStr="";
    while ($Row=$Sql->Row()) {
        $SelectArr[]="DATE_FORMAT(MIN(C{$Row->ID}.NEXT_ARCHIVE_START_DATE),'%Y-%m-%d') AS M{$Row->ID}";
        $SelectArr[]="UNIX_TIMESTAMP(MIN(C{$Row->ID}.NEXT_ARCHIVE_START_DATE)) AS U{$Row->ID}";
        $FromArr[]=PFX."_tracker_{$Row->ID}_static_archive_cache C{$Row->ID}";
        $CpArr[]=$Row->ID;
        $ClientNames[$Row->ID]=$Row->NAME;
    }

    if ($Settings['All']->ARCHIVE_ENABLE) {
        if (!$NoComment) echo "Using archiving dates.\n";
        $SelectStr=implode(", ",$SelectArr);
        $FromStr=implode(", ",$FromArr);
        $Query = "SELECT $SelectStr FROM $FromStr";
        $MinDates=$Db->Select($Query);
        $MinStamp=time();
        foreach ($CpArr as $CpId) {
            $U="U$CpId";
            $M="M$CpId";
            if ($MinDates->$U<$MinStamp) {
                $MinStamp=$MinDates->$U;
                $MinDeleteDate=$MinDates->$M;
            }
        }
    }

    $Funcs=explode("|",$Settings['All']->DELETE_FUNCS);
    $SubFuncs=explode("|",$Settings['All']->DELETE_SUB_FUNCS);
    if (empty($Filter)) foreach ($Funcs as $k) if ($k) $Filter[$k]=1;
    foreach ($SubFuncs as $k) if ($k) $Filter[$k]=1;

    $CpPeriod = array();
    $CpRange = array();
    $CpTZ = array();
    $DisableRemoval = array();
    $Query = "SELECT COMPANY_ID, DELETE_ENABLE, DELETE_KEEP_PERIOD, TIMEZONE,
                     DELETE_RANGE_START, DELETE_RANGE_END  
                     FROM ?_config WHERE SITE_ID=0";
    $Sql = new Query($Query);
    while ($Row=$Sql->Row()) {
        $StartDate = $EndDate = false;
        $CpTZ[$Row->COMPANY_ID]=$Row->TIMEZONE;
        if ($Row->DELETE_ENABLE==0 && !($AjaxMode && $Row->COMPANY_ID==0)) $DisableRemoval[]=$Row->COMPANY_ID;
        if (!$Row->DELETE_KEEP_PERIOD && !$Row->DELETE_RANGE_START && !$Row->DELETE_RANGE_END) continue;
        if ( (!$Row->DELETE_RANGE_START || !$Row->DELETE_RANGE_END) && $Row->DELETE_KEEP_PERIOD) {
            $EndDate=GetKeepPeriodDate($Row->DELETE_KEEP_PERIOD);
            if ($MinDeleteDate) {
                $Query = "SELECT IF(? < ?, ?, ?)";
                $EndDate=$Db->ReturnValue($Query,$MinDeleteDate,$EndDate,$MinDeleteDate,$EndDate);
            }
        }
        elseif ($Row->DELETE_RANGE_START && $Row->DELETE_RANGE_END) {
            $StartDate = $Row->DELETE_RANGE_START;
            $EndDate = $Row->DELETE_RANGE_END;
            if ($MinDeleteDate && $StartDate) {
                $Query = "SELECT IF(? < ?, ?, ?)";
                $StartDate=$Db->ReturnValue($Query,$MinDeleteDate,$StartDate,$MinDeleteDate,$StartDate);
            }
            if ($MinDeleteDate && !$StartDate) {
                $Query = "SELECT IF(? < ?, ?, ?)";
                $EndDate=$Db->ReturnValue($Query,$MinDeleteDate,$EndDate,$MinDeleteDate,$EndDate);
            }
        }

        if ($Row->COMPANY_ID==0) {
            if (@$StartDate) $Filter['StartTime']=$StartDate; 
            if (@$EndDate) $Filter['EndTime']=$EndDate;
        }
        elseif (!$Row->DELETE_RANGE_START && !$Row->DELETE_RANGE_END) {
            $CpPeriod[$Row->COMPANY_ID]=$EndDate;
        }
        else {
            if (@$StartDate) $CpRange[$Row->COMPANY_ID]['StartTime'] = $StartDate;
            if (@$EndDate) $CpRange[$Row->COMPANY_ID]['EndTime'] = $EndDate;
        }
    }
    if (!empty($CpPeriod)) $Filter['CpKeep']=$CpPeriod;
    if (!empty($CpRange)) $Filter['CpRange']=$CpRange;
    $Filter['CpTZ']=$CpTZ;
    if (count($CpArr)==1) $DisableRemoval=array();

    if (!@$Filter['EndTime'] && !@$Filter['StartTime'] && empty($CpKeep) && empty($CpRange)) {
        if (!$NoComment) echo "No removal periods defined...\n";
        return false;
    }

    global $RemovalTablesStat,$RemovalKey,$RemovedSpace;
    $StatusBefore=V($Filter['DisableOptimize'])?false:GetTableStatus();

    if (!$NoComment) echo "Turning off tracking...\n";
    SetTrackingWork(0);

    $CpuArr[]=($AjaxMode)?0:GetCpuLoad(false, $NoComment);

    $Aff=0;
    $T=0;

    if (!V($Filter['KeepStat'])) {
        $RemovalKey='x-log';
        if (!$NoComment) echo "Removing statistics...\n";
        foreach ($CpArr as $CpId) {
            if (in_array($CpId,$DisableRemoval)) continue;
            if (!$AjaxMode) {
                CheckCpuLoad($CpId);
                if (IsCronTaskFinished()) return false;
            }
            $Time=$Db->GetMicrotime();
            if (!$NoComment) echo "{$ClientNames[$CpId]}: ";
            $Aff+=DeleteLogStat($CpId,$Filter);
            if (!$NoComment) echo "ok.\n";
            $Time1=$Db->GetMicrotime();
            $T+=$Time1-$Time;
        }

        $CpuArr[]=($AjaxMode)?0:GetCpuLoad(false, $NoComment);
        if (!$AjaxMode) UpdateCronDeleteLog($CpuArr[count($CpuArr)-2], $CpuArr[count($CpuArr)-1], $Aff, 'x-log', $T);
        if (!$NoComment) echo "Removed rows: $Aff\n";
    } else $CpId=0;
    
    $Aff1=0;
    
    if (V($Filter['Ref'])) $Aff1+=RunDeleteFunc("DeleteOrphanReferers", $CpId, $CpuArr, $CpArr, $Filter, "Referrers", 'x-ref');
    if (V($Filter['Ref'])) $Aff1+=RunDeleteFunc("DeleteOrphanHost", $CpId, $CpuArr, $CpArr, $Filter, "Hosts", 'x-host');
    if (V($Filter['Key'])) $Aff1+=RunDeleteFunc("DeleteOrphanKey", $CpId, $CpuArr, $CpArr, $Filter, "Keywords", 'x-key');
    if (V($Filter['Vis'])) $Aff1+=RunDeleteFunc("DeleteOrphanVisitors", $CpId, $CpuArr, $CpArr, $Filter, "Visitors", 'x-vis');
    if (V($Filter['Vis'])) $Aff1+=RunDeleteFunc("DeleteOrphanBrowser", $CpId, $CpuArr, $CpArr, $Filter, "Agents", 'x-agent');
    if (V($Filter['Vis'])) $Aff1+=RunDeleteFunc("DeleteOrphanIp", $CpId, $CpuArr, $CpArr, $Filter, "Ips", 'x-ip');
    if (V($Filter['Vis'])) $Aff1+=RunDeleteFunc("DeleteOrphanTags", $CpId, $CpuArr, $CpArr, $Filter, "Tags", 'x-tag');
    if (V($Filter['Addr'])) $Aff1+=RunDeleteFunc("DeleteOrphanAddr", $CpId, $CpuArr, $CpArr, $Filter, "Pages", 'x-addr');
    if (V($Filter['SItem'])) $Aff1+=RunDeleteFunc("DeleteOrphanSaleItem", $CpId, $CpuArr, $CpArr, $Filter, "Sale items", 'x-sale');
    if (V($Filter['AItem'])) $Aff1+=RunDeleteFunc("DeleteOrphanActionItem", $CpId, $CpuArr, $CpArr, $Filter, "Action items", 'x-action');

    //  
    if ($Aff>0) foreach ($CpArr as $CpId) $Db->Query("DELETE FROM ?_{$CpId}_cache_data");

    $Stamp=gmdate("Y-m-d H:i:s", time());
    $Query = "DELETE FROM ?_report_time_stat";
    $Db->Query($Query);

    if (!$AjaxMode && IsCronTaskFinished()) return false;
    //    ,    
    if (!V($Filter['DisableOptimize'])) {
        //$Query="SHOW TABLE STATUS";
        //$Sql = new Query($Query);
        if (!$NoComment) echo "Optimizing tables...\n";
        foreach ($RemovalTablesStat as $k=>$a) {
            foreach ($a as $Table) {
            //while ($Row=$Sql->Row()) {
            //if (strpos($Row->Name, PFX."_tracker")===false) continue;
            if (!$NoComment) echo $Table.": ";
            $Db->Query("OPTIMIZE TABLE $Table");
            if (!$NoComment) echo "ok\n";
        }}
    }

    if (!$NoComment) echo "Turning on tracking...\n";
    SetTrackingWork(1);

    if (!$NoComment) echo "Calculating removed space...\n";
    $StatusAfter=V($Filter['DisableOptimize'])?false:GetTableStatus();
    if (!V($Filter['DisableOptimize'])) {
        $RemovedSpace=CalcDeletedSpace($StatusBefore,$StatusAfter,$RemovalTablesStat,$AjaxMode);
    }
    
    if (!$AjaxMode) {
        $NextDate=GetNextDeleteDate($Settings['All']->DELETE_RUN_PERIOD,$GmTime);
        $Query = "UPDATE ?_config SET DELETE_NEXT_DATE = ?, DELETE_RUN_NOW=0 WHERE COMPANY_ID=0 AND SITE_ID=0";
        $Db->Query($Query,$NextDate);
    }
    if (!$NoComment) echo "Done.\n\n\n";

    $Aff+=$Aff1;

    return $Aff;
}


function RunDeleteFunc($Func, $CpId, &$CpuArr, $CpArr, $Filter, $Name, $LogKey, $NoComment=NO_CRON_COMMENTS)
{
    global $Db,$RemovalKey;
    $AjaxMode=!defined("CRON_MODE");
    $RemovalKey=$LogKey;
    if (!$AjaxMode) {
        CheckCpuLoad($CpId);
        if (IsCronTaskFinished()) return false;
    }
    $Time=$Db->GetMicrotime();
    $Aff=$Func($CpArr, $Filter);
    $Time1=$Db->GetMicrotime();    
    $CpuArr[]=($AjaxMode)?false:GetCpuLoad(false, $NoComment);
    if (!$AjaxMode) UpdateCronDeleteLog($CpuArr[count($CpuArr)-2], $CpuArr[count($CpuArr)-1], $Aff, $LogKey, $Time1-$Time);
    if (!$NoComment) echo "{$Name}: {$Aff}\n";    
    return $Aff;
}


function EnableTracking()
{
    SetTrackingWork(1);
}

function SetTrackingWork($Mode=0)
{
    global $Db;
    $Mode=($Mode==1)?0:1;
    $Query = "UPDATE ?_config SET STOP_TRACKING =? WHERE COMPANY_ID=0 AND SITE_ID=0";
    $Db->Query($Query,$Mode);
}


function GetTableStatus()
{
    $Status=array();
    $Query = "SHOW TABLE STATUS";
    $Sql = new Query($Query);
    while ($Row=$Sql->Row()) {
        $Status[$Row->Name]=array('Rows'=>$Row->Rows,'Size'=>($Row->Data_length+$Row->Index_length));
    }
    return $Status;
}




function CalcDeletedSpace($Before,$After,$Keys,$ReturnOnly=false)
{
    global $Db,$CurrentTaskId;
    $ReturnArr=array();
    
    foreach ($Keys as $Key=>$Tables) {
        $Deleted=0;
        foreach ($Tables as $Table) {
            if ($Before[$Table]['Rows']==0) continue;
            $PerRow=$Before[$Table]['Size']/$Before[$Table]['Rows'];
            $Deleted+=$PerRow*($Before[$Table]['Rows']-$After[$Table]['Rows']);
        }
        $Deleted=round($Deleted,0);
        if (!$ReturnOnly) {
            $Query = "UPDATE ?_cron_delete_log SET DELETED_SPACE=? WHERE TASK_PROCESS_ID=? AND MESSAGE=?";
            $Db->Query($Query,$Deleted,$CurrentTaskId,$Key);
        }
        else $ReturnArr[$Key]=$Deleted;
    }
    return $ReturnArr;
}

?>