<?

function GetKeepPeriodDate($Period='')
{
    global $Db, $Logs;
    if (!$Period) return false;
    $Now=gmdate("Y-m-d H:i:s", time());
    $Intervals['d']="DAY";
    $Intervals['w']="WEEK";
    $Intervals['m']="MONTH";
    $Intervals['y']="YEAR";
    $Arr=explode("-",$Period);
    $Num=$Arr[0];
    $I=$Intervals[$Arr[1]];
    if($I=='WEEK') {
        $I='DAY';
        $Num=$Num*7;
    }
    
    $Date=$Db->ReturnValue("SELECT DATE_FORMAT(DATE_ADD(?, INTERVAL -$Num $I),'%Y-%m-%d %H:%i:%s')",$Now);
    return $Date;
}


function GetNextArchivePeriod($CpArr=array(),$ReportId=0, $Period='')
{
    global $Db, $Logs;
    if (!$Period) return false;
    static $MinStamp=false;
    static $CpMinStamp=array();

    $Arr=explode("-",$Period);
    $Num=$Arr[0];
    $P=$Arr[1];
    $Num3=0;
    $Num2=$Num;
    $Intervals['d']="DAY";
    $Intervals['w']="WEEK";
    $Intervals['m']="MONTH";
    $Intervals['y']="YEAR";
    $I=$Intervals[$P];
    if ($P=="w") { $I="DAY"; $Num2=($Num2*7); }
    if ($P!='d') $Num3=-1;
    if ($P=='y') $Num3=2;
    $Now=false;

    $Query = "SELECT COMPANY_ID FROM ?_static_report WHERE ID=?";
    $CpId=$Db->ReturnValue($Query,$ReportId);
    if ($CpId>0) $CpArr=array(0=>$CpId);
    
    $Ranges=array();
    
    foreach ($CpArr as $CpId) {
        $LastDate=false;
        $LastStamp=false;
        $Query = "SELECT MAX(UNIX_TIMESTAMP(END_DATE)) FROM ?_archive WHERE COMPANY_ID=? AND REPORT_ID=? AND PERIOD=?";
        $Stamp=$Db->ReturnValue($Query,$CpId,$ReportId,$Period);
        if ($Stamp) $LastStamp=$LastStamp?min($LastStamp,$Stamp):$Stamp;
        if ($LastStamp) $LastDate=date("Y-m-d",$LastStamp);
        if ($LastDate) $Now=$Db->ReturnValue("SELECT DATE_ADD(DATE_ADD('$LastDate', INTERVAL ".(($P!='y'?2:1)*$Num2)." $I), INTERVAL $Num3 DAY)");

        if (!$LastDate) {
            if (!isset($CpMinStamp[$CpId])) {
                $MinU=time();
                $MinStamp=$Now;
                $Query = "SELECT MIN(STAMP) AS M, UNIX_TIMESTAMP(MIN(STAMP)) AS U FROM ?_{$CpId}_stat_log";
                $Check=$Db->Select($Query);
                if ($Check->U>0&&$Check->U<$MinU) { $MinU=$Check->U; $MinStamp=$Check->M; }
                $CpMinStamp[$CpId]=$MinStamp;
            }
            $LastDate=$CpMinStamp[$CpId];
            if ($LastDate) $Now=$Db->ReturnValue("SELECT DATE_ADD(DATE_ADD('$LastDate', INTERVAL $Num2 $I), INTERVAL $Num3 DAY)");
        }
    
        if (!$Now) $Now=gmdate("Y-m-d H:i:s", time());
        //$Logs->Msg("$CpId - $Period - $Now");
        
        if ($P=="d") $Func=" (DATE_ADD('$Now', INTERVAL -{NUM} DAY)) ";
        if ($P=="w") $Func=" (DATE_ADD('$Now', INTERVAL -((IF(DAYOFWEEK('$Now')=1,7,DAYOFWEEK('$Now')-1))+(7*{NUM}))+1 DAY)) ";
        if ($P=="m") $Func=" ((PERIOD_ADD(EXTRACT(YEAR_MONTH FROM '$Now'), -{NUM})*100)+1) ";
        if ($P=="y") $Func="  (( (EXTRACT(YEAR FROM '$Now')-{NUM} )*100+1)*100+1) ";
        $Query = "SELECT DATE_FORMAT(".str_replace("{NUM}", $Num, $Func).", '%Y-%m-%d')";
        $Date=$Db->ReturnValue($Query);
        $Date.=" 00:00:00";
    
        $Date2=$Db->ReturnValue("SELECT DATE_ADD('$Date', INTERVAL $Num2 $I)");
        $Date2=$Db->ReturnValue("SELECT DATE_ADD('$Date2', INTERVAL -1 DAY)");
        $Date2=str_replace("00:00:00", "23:59:59", $Date2);
        
        $Ranges[$CpId]=array(0=>$Date, 1=>$Date2);
    }

    return $Ranges;
}


// gmt
function GetNextDeleteDate($Period='', $FromNow=0)
{
    global $Db, $Logs;
    if (!$Period) return false;
    $Now=gmdate("Y-m-d H:i:s", time());
    $LastStamp=false;

    $Query = "SELECT ID FROM ?_cron_log WHERE TASK='DELETE' AND FINISHED=1";
    $NotFirst=$FromNow?1:$Db->ReturnValue($Query);

    if ($NotFirst) {
        $Query="SELECT STAMP FROM ?_cron_log WHERE TASK='DELETE' AND FINISHED=1 ORDER BY STAMP DESC";
        $LastStamp=$FromNow?$FromNow:$Db->ReturnValue($Query);
    }

    $DayTime['n']="00:00:01"; // night
    $DayTime['m']="06:00:01"; // morning
    $DayTime['d']="12:00:01"; // day
    $DayTime['e']="18:00:01"; // evening

    $Arr=explode("|",$Period);
    $Num=$Arr[0];
    $P=$Arr[1];
    $T=$Arr[2];

    if (!$NotFirst) {
        if ($P=="d") $Func=" (DATE_ADD('$Now', INTERVAL {NUM} DAY)) ";
        if ($P=="w") $Func=" (DATE_ADD('$Now', INTERVAL ((7-(IF(DAYOFWEEK('$Now')=1,7,DAYOFWEEK('$Now')-1)))+(7*{NUM}))+1 DAY)) ";
        if ($P=="m") $Func=" ((PERIOD_ADD(EXTRACT(YEAR_MONTH FROM '$Now'), +{NUM})*100)+1) ";
        if ($P=="y") $Func="  (( (EXTRACT(YEAR FROM '$Now')+{NUM} )*100+1)*100+1) ";
        $Query = "SELECT DATE_FORMAT(".str_replace("{NUM}", $Num, $Func).", '%Y-%m-%d')";
        $Date=$Db->ReturnValue($Query);
        $Date.=" ".$DayTime[$T];
        return $Date;
    }
    else {
        $Intervals['d']="DAY";
        $Intervals['w']="WEEK";
        $Intervals['m']="MONTH";
        $Intervals['y']="YEAR";
        $I=$Intervals[$P];
        if ($P=="w") {
            $I="DAY";
            $Num=($Num*7)-1;
        }
        $Query = "SELECT DATE_FORMAT(DATE_ADD('$LastStamp', INTERVAL +$Num $I), '%Y-%m-%d')";
        $Date=$Db->ReturnValue($Query);
        $Date.=" ".$DayTime[$T];
        return $Date;        
    }
    
}

function SetMinArchiveDate($ReportId,$CpArr,$PeriodId)
{
    global $Db;
    $MinU=time();
    $MinStamp=false;

    foreach ($CpArr as $CpId) {
            $Query = "SELECT 
                            MIN(NEXT_ARCHIVE_START_DATE) AS M,
                            MIN(UNIX_TIMESTAMP(NEXT_ARCHIVE_START_DATE)) AS U 
                            FROM ?_{$CpId}_static_archive_cache
                            WHERE REPORT_ID=? AND PERIOD_ID=?";
            $Stamp=$Db->Select($Query,false,$ReportId,$PeriodId);
            if ($Stamp->U<$MinU) {
                $MinU=$Stamp->U;
                $MinStamp=$Stamp->M;
            }
    }
    
    $Query = "UPDATE ?_static_report_archive SET MIN_ARCHIVE_START_DATE = ? WHERE ID=?";
    $Db->Query($Query,$MinStamp,$PeriodId);
}

function SetArchivePeriod($Report,$CpArr,$Tpl,$PId=false)
{
    global $Db;
    $Ranges=GetNextArchivePeriod($CpArr,$Report->ID,$Tpl);
    if (!$PId) {
        $Query = "SELECT ID FROM ?_static_report_archive WHERE REPORT_ID=? AND PERIOD=?";
        $CheckId=$Db->ReturnValue($Query,$Report->ID,$Tpl);
        $PId=$CheckId;    
    }
    if (!$PId) {
        $Query="INSERT INTO ?_static_report_archive (REPORT_ID,PERIOD)
                        VALUES (?,?)";
        $Db->Query($Query,$Report->ID,$Tpl);
        $PId=$Db->LastInsertId;
    }
    else {
        //$Query="UPDATE ?_static_report_archive SET WHERE REPORT_ID=? AND PERIOD=?";
        //$Db->Query($Query,$Report->ID,$Tpl);
    }
    
    $SiteArr=explode(";",$Report->SITES);

    foreach ($CpArr as $CpId) {
        if (!isset($Ranges[$CpId])) continue;
        $Arr=explode(" ",$Ranges[$CpId][0]);
        $StartDate=$Arr[0];
        $Arr=explode(" ",$Ranges[$CpId][1]);
        $EndDate=$Arr[0];

        $Query = "
            SELECT QS.PARAMS_SET
                FROM ?_{$CpId}_static_report_cache SRC
                    INNER JOIN ?_{$CpId}_cache C
                        ON C.ID=SRC.CACHE_ID
                    INNER JOIN ?_{$CpId}_cache_query_set QS
                        ON QS.ID=C.QUERY_SET_ID
                WHERE SRC.REPORT_ID=?
        ";
        $Params=$Db->Select($Query,false,$Report->ID);
        if (!$Params) continue;
        $Params=unserialize($Params->PARAMS_SET);
        unset($Params['DynamicPeriod']);
        $Params['StartDate']=$StartDate;
        $Params['EndDate']=$EndDate;
        foreach ($SiteArr as $SiteId) {
            $Params['SiteId']=$SiteId;
            $Cache = new nsQueryCache($CpId);
            $Cache->QueryParams=$Params;
            $Cache->Mode=$Report->MODE;
            $Cache->GetQuerySetId();
            $Cache->GetCacheId();
            if (!$Cache->CacheId) $Cache->CreateCacheRecord(0);
            $Cache->SetCacheType(3);
            $CacheId=$Cache->CacheId;

            $Query = "SELECT ID FROM ?_{$CpId}_static_archive_cache WHERE REPORT_ID=? AND PERIOD_ID=? AND SITE_ID=?";
            $CheckId=$Db->ReturnValue($Query,$Report->ID,$PId,$SiteId);
            if (!$CheckId) {
                $Query = "INSERT INTO ?_{$CpId}_static_archive_cache (REPORT_ID, PERIOD_ID, SITE_ID, CACHE_ID,
                                    NEXT_ARCHIVE_START_DATE,NEXT_ARCHIVE_END_DATE)
                                VALUES (?,?,?,?,?,?)";
                $Db->Query($Query,$Report->ID,$PId,$SiteId,$CacheId,$Ranges[$CpId][0],$Ranges[$CpId][1]);
                $CheckId=$Db->LastInsertId;
            }
            else {
                $Query = "UPDATE ?_{$CpId}_static_archive_cache SET 
                                    CACHE_ID=?,
                                    NEXT_ARCHIVE_START_DATE=?, NEXT_ARCHIVE_END_DATE=?
                                    WHERE ID=?";
                $Db->Query($Query, $CacheId, $Ranges[$CpId][0],$Ranges[$CpId][1], $CheckId);
            }
        }
    }
    
    return $PId;
}



?>