<?

require_once SYS."/system/lib/validate.func.php";

function GetPqId($Addr='',$SiteId=0, $AnySite=false)
{
    global $Db;
    $Addr = trim($Addr);
    $Arr=PreparePathAddr($Addr);
    if (!$Arr) return 0;
    if (!$Arr['host']) return 'nohost';
    $SiteHostId=GetPageHostId($Arr['host'],$SiteId, $AnySite);
    if (!$SiteHostId) return 'nohost';
    if ($SiteHostId=='host') return 'host';

    if (!$SiteId) $SiteId=$Db->ReturnValue("SELECT SITE_ID FROM ?_site_host WHERE ID=?",$SiteHostId);
    $PageId=GetPageId($Arr, $SiteId);
    $QueryId=GetQueryId($Arr['query']);

    $Query = "SELECT ID FROM ?_page_query WHERE SITE_HOST_ID=? AND PAGE_ID=? AND QUERY_ID=?";
    $PqId= $Db->ReturnValue($Query,$SiteHostId,$PageId,$QueryId);
    if (!$PqId) {
        $Query = "INSERT INTO ?_page_query (SITE_ID,SITE_HOST_ID,PAGE_ID,QUERY_ID) VALUES (?,?,?,?)";
        $Db->Query($Query,$SiteId,$SiteHostId,$PageId,$QueryId);
        return $Db->LastInsertId;
    }
    return $PqId;
}


function PreparePathAddr($Addr)
{
    $Addr = trim($Addr);
    $Arr=@parse_url(urldecode(urldecode($Addr)));
    if (!isset($Arr['path'])) $Arr['path']="";
    $Arr['path']=ereg_replace("/+", "/", $Arr['path']);
    if ($Arr['path']=="") $Arr['path']="/";
    if (!ValidVar($Arr['host'])) return false;
    $Arr['host']=ToLower($Arr['host']);
    if (!isset($Arr['query'])) $Arr['query']="";
    return $Arr;
}

function GetPageHostId($Host,$SiteId=false,$AnyHost=false)
{
    global $Db;
    $Where=($SiteId)?" AND SITE_ID=?":"";
    $Query = "SELECT ID, SITE_ID FROM ?_site_host WHERE HOST=? $Where";
    $Sql = new Query($Query,false,$Host,$SiteId);
    $Hosts=array();
    while ($Row=$Sql->Row()) $Hosts[$Row->SITE_ID]=$Row->ID;

    if (empty($Hosts)&&$SiteId) {
        $Query = "INSERT INTO ?_site_host (SITE_ID, HOST, ENABLED) VALUES (?,?,?)";
        $Db->Query($Query,$SiteId,$Host,1);
        return $Db->LastInsertId;
    }

    if (count($Hosts)==1 || (count($Hosts)>1 && $AnyHost)) foreach ($Hosts as $HostId) return $HostId;
    if (count($Hosts)>1) return 'host';
    if (empty($Hosts)) return false;
}

function GetPageId($PathArr=false, $StId=false)
{
    global $Db;
    $Path=$PathArr['path'];
    $Query = "SELECT ID FROM ?_site_page WHERE PATH = ? AND SITE_ID=?";
    $CheckId=$Db->ReturnValue($Query, $Path, $StId);
    if (ValidId($CheckId)) return $CheckId;
    $Query = "INSERT INTO ?_site_page (SITE_ID, PATH) VALUES (?, ?)";
    $Db->Query($Query, $StId, $Path);
    return $Db->LastInsertId;
}

function GetQueryId($Qr=false)
{
    if (!$Qr) return 0;
    global $Db; 
    $Qr=escape_string($Qr);
    $Query = "SELECT ID FROM ?_query WHERE MD5_SEARCH=MD5(?)";
    $CheckId=$Db->ReturnValue($Query, $Qr);
    if (ValidId($CheckId)) return $CheckId;
    $Query ="INSERT INTO ?_query (QUERY_STRING, MD5_SEARCH) VALUES (?, MD5(?))";
    $Db->Query($Query, $Qr, $Qr);
    return (ValidId($Db->LastInsertId))?$Db->LastInsertId:0;
}


?>