<?

require_once SELF."/class/cache_v2.class.php";
require_once SELF."/lib/reports/create_cache.func.php";
require_once SELF."/lib/reports/misc.func.php";
require_once SELF."/lib/reports/hidden_reports.func.php";

function DeleteStaticReport($Id,$CompId=false,$NoRedir=false) 
{
    global $Db, $nsProduct, $nsUser, $CpId;
    if (!$CompId) $CompId=$CpId;
    
    $Query="SELECT * FROM ?_static_report WHERE ID=?";
    $EditReport=$Db->Select($Query,false,$Id);
    if (!$EditReport) $nsProduct->Redir("reports");   
    $AllowEdit=false;
    if ($nsUser->SUPER_ADMIN || ($nsProduct->LICENSE==2 && $nsUser->SUPER_USER)) $AllowEdit=true;
    if (!$AllowEdit && $EditReport->COMPANY_ID>0 && $nsUser->UserId()==$EditReport->USER_ID) $AllowEdit=true;
    if (!$AllowEdit) $nsProduct->Redir("reports");     


    $Query = "SELECT CACHE_ID, REPORT_ID FROM ?_{$CompId}_static_report_cache WHERE REPORT_ID=?";
    $Sql = new Query($Query, false, $Id);
    $CacheArr=array();
    while ($Row=$Sql->Row()) $CacheArr[$Row->CACHE_ID]=$Row->REPORT_ID;

    foreach ($CacheArr as $CacheId=>$ReportId) {
        $Query = "SELECT ID FROM ?_{$CompId}_static_report_cache WHERE CACHE_ID=? AND REPORT_ID != ?";
        $CheckId=$Db->ReturnValue($Query, $CacheId, $Id);
        if (!$CheckId) {
            $Query = "UPDATE ?_{$CompId}_cache SET CACHE_TYPE ='0' WHERE ID = ?";
            $Db->Query($Query,$CacheId);
        }
    }
    $Query = "SELECT GROUP_ID FROM ?_static_report WHERE ID=?";
    $Tab=$Db->ReturnValue($Query,$Id);

    $Query = "DELETE FROM ?_static_report WHERE ID = ?";
    $Db->Query($Query, $Id);
    $Query = "DELETE FROM ?_watch WHERE REPORT_ID = ?";
    $Db->Query($Query, $Id);
    $Query = "DELETE FROM ?_archive WHERE REPORT_ID = ?";
    $Db->Query($Query, $Id);

    $CpArr=array();
    $Query = "SELECT ID FROM ?_client";
    $Sql = new Query($Query);
    while ($Row=$Sql->Row()) $CpArr[]=$Row->ID;
    foreach ($CpArr as $CpId) {
        $Db->Query("DELETE FROM ?_{$CpId}_static_report_cache WHERE REPORT_ID =?",$Id);
        $Db->Query("DELETE FROM ?_{$CpId}_static_archive_cache WHERE REPORT_ID =?",$Id);
    }    

    if (!$NoRedir) $nsProduct->Redir("reports", "Tab=$Tab", "admin");
}

function DeleteReportGroup($Id,$CpId)
{
    global $Db,$nsProduct;
    $Query = "SELECT ID, COMPANY_ID FROM ?_static_report WHERE GROUP_ID=?";
    $Sql = new Query($Query, false, $Id);
    while ($Row=$Sql->Row()) DeleteStaticReport($Row->ID,$Row->COMPANY_ID,1);
    $Query = "DELETE FROM ?_static_report_group WHERE ID=?";
    $Db->Query($Query, $Id);
    $nsProduct->Redir("report_group", "RDlt=1", "admin");
}




function SetUpdateTime($ReportId=false, $PeriodId=false, $Time=false) 
{
    global $Db;
    if (!$ReportId || !$PeriodId) return false;
    if (!$Time) $Time=$Db->ReturnValue("SELECT DATE_ADD(?, INTERVAL -1 DAY)",gmdate("Y-m-d H:i:s", time()));
    global $Db;
    $Query = "UPDATE ?_static_report_periods SET NEXT_UPDATE_TIME = ? WHERE ID=?";
    $Db->Query($Query,$Time,$PeriodId);
}


function NextUpdateTime($CpId=false,$ReportId=false,$PeriodId=false,$T=false,$DT=false,$UPC=false,$UP=false)
{
    if (!$ReportId) return false;
    if (!$CpId) return false;
    if (!$PeriodId && (!$T || !$DT || !$UPC || !$UP) ) return false;
    global $Db;
    $UpdateTime=false;
    
    $TZ=$Db->ReturnValue("SELECT TIMEZONE FROM ?_config WHERE COMPANY_ID=? AND SITE_ID=0", $CpId);
    $TZ=intval($TZ);
    
    if ($PeriodId && (!$T || !$DT || !$UPC || !$UP) ) {
        $Query = "SELECT * FROM ?_static_report_periods WHERE ID=?";
        $Check=$Db->Select($Query, false, $PeriodId);
        $T=$Check->PERIOD;
        $DT=$Check->DAY_TIME;
        $UPC=$Check->UPDATE_PERIOD_CNT;
        $UP=$Check->UPDATE_PERIOD;
    }

    $DayTime[1]="06:00:01"; // morning
    $DayTime[2]="12:00:01"; // day
    $DayTime[3]="18:00:01"; // evening
    $DayTime[4]="00:00:01"; // night
    
    $NextDate=false;
    $GMTime=$Now=gmdate("Y-m-d H:i:s", time());
    $Now=$Db->ReturnValue("SELECT DATE_FORMAT(DATE_ADD('$Now', INTERVAL '".SqlTZ($TZ)."' HOUR_MINUTE), '%Y-%m-%d %H:%i:%s')");
    $Arr=explode("-",$T);

    //  1-d-0
    if ($Arr[2]==0 && $Arr[0]!=0) {
        //   
        // ,   
        $P="";
        if ($Arr[1]=="h" || $UP=='h') {
            $Func=" DATE_ADD( DATE_ADD('$Now', INTERVAL '".SqlTZ($TZ)."' HOUR_MINUTE), INTERVAL $UPC HOUR) ";
            $Query = "SELECT DATE_FORMAT($Func, '%Y-%m-%d %H')";
            $UpdateTime=$Db->ReturnValue($Query).":00:01";
        }
        else {
            if ($Arr[1]=='d') {
                $P="DAY";
                $TPL="%Y-%m-%d";
                $Add="";
            }
            if ($Arr[1]=='w') {
                $P="DAY";
                $UPC=$UPC*7;
                $DW=$Db->ReturnValue("SELECT DATE_FORMAT('$Now','%w')");
                if ($DW==0) $DW=7;
                $UPC-=($DW-1);
                $TPL="%Y-%m-%d";
                $Add="";
            }
            if ($Arr[1]=='m') {
                $P="MONTH";
                $TPL="%Y-%m";
                $Add="-01";
            }
            if ($Arr[1]=='y') {
                $P="YEAR";
                $TPL="%Y";
                $Add="-01-01";
            }
            $Query = "SELECT DATE_FORMAT( DATE_ADD('$Now', INTERVAL $UPC $P), '$TPL' )";
            $NextDate=$Db->ReturnValue($Query);
            $NextDate.=$Add;
            $NextDate.=" ".$DayTime[$DT];
            $UpdateTime=$NextDate;
        }
        
    }
    
    //  1-d-1 || 0-d-0 || 0-d-1
    if ($Arr[2]==1 || $Arr[0]==0) {
        //   
        if ($UP=='h') {
            //       Now
            $P="HOUR";
            $TPL="%Y-%m-%d %H";
            $Add=":00:01";
        }        
        if ($UP=='d') {
            $P="DAY";
            $TPL="%Y-%m-%d";
            $Add="";
        }
        if ($UP=='w') {
            $P="DAY";
            $UPC=$UPC*7;
            $DW=$Db->ReturnValue("SELECT DATE_FORMAT('$Now','%w')");
            if ($DW==0) $DW=7;
            $UPC-=($DW-1);            
            $TPL="%Y-%m-%d";
            $Add="";
        }        
        if ($UP=='m') {
            $P="MONTH";
            $TPL="%Y-%m";
            $Add="-01";
        }    
        if ($UP=='y') {
            $P="YEAR";
            $TPL="%Y";
            $Add="-01-01";
        }            
        $Query = "SELECT DATE_FORMAT( DATE_ADD('$Now', INTERVAL $UPC $P), '$TPL' )";
        $NextDate=$Db->ReturnValue($Query);
        $NextDate.=$Add;
        
        if ($UP!='h') {
            $NextDate.=" ".$DayTime[$DT];
            if ($UP=='d'&&$TZ&&$Db->ReturnValue("SELECT IF(DATE_ADD('$NextDate', INTERVAL -$UPC $P)>'$Now',1,0)")) {
                $NextDate=$Db->ReturnValue("SELECT DATE_ADD('$NextDate', INTERVAL -$UPC $P)");
            }
        }
        $UpdateTime=$NextDate;  
    }

    $TZ=0;
    $UpdateTime=$Db->ReturnValue("SELECT DATE_FORMAT( DATE_ADD('$UpdateTime', INTERVAL '".SqlTZ($TZ)."' HOUR_MINUTE) , '%Y-%m-%d %H:%i:%s')");
    //$UpdateTime=$Db->ReturnValue("SELECT DATE_FORMAT( '$UpdateTime', '%Y-%m-%d %H:%i:%s')");
    return $UpdateTime;
}




function ImportStaticReport($ReportId)
{
    global $Db, $StaticMode, $CpId, $Lang, $CurrentCompany, $nsProduct, $nsUser, $EditStaticReport;
    $Query = "
        SELECT 
            
            C.ID, QS.PARAMS_SET,
            QS.ID AS QUERY_SET_ID,
            SR.SITES,
            SR.COMPANY_ID, SR.NAME, SR.USER_ID,
            SR.ADDITIONAL_TASK
            
            FROM ?_static_report SR
            INNER JOIN ?_{$CpId}_static_report_cache SRC
                ON SRC.REPORT_ID=SR.ID
            INNER JOIN ?_{$CpId}_cache C
                ON C.ID=SRC.CACHE_ID
            INNER JOIN ?_{$CpId}_cache_query_set QS
                ON QS.ID=C.QUERY_SET_ID
        WHERE SR.ID = ?
    ";
    $Rep=$Db->Select($Query, false, $ReportId);
    $EditStaticReport=false;
    if ($Rep->USER_ID==$nsUser->UserId() || 
        $nsUser->SUPER_ADMIN || ($nsProduct->LICENSE==2&&$nsUser->SUPER_USER)) {
        $EditStaticReport=true;
    }
    if (!$Rep) return false;
    if (isset($Lang[$Rep->NAME])) $Rep->NAME=$Lang[$Rep->NAME];
    global $StaticReportName;
    $StaticReportName=$Rep->NAME;
    $Params=unserialize($Rep->PARAMS_SET);
    $WhereArr=V($Params['WhereArr']);
    unset($Params['WhereArr']);
    if ($Rep->ADDITIONAL_TASK) {
        $Arr=explode(";",$Rep->ADDITIONAL_TASK);
        foreach ($Arr as $AT) {
            $SubArr=explode("=",$AT);
            if ($SubArr[0]=="OrderBy") {
                $GLOBALS['OrderBy'] = $SubArr[1];
                $WhereArr[count($WhereArr)-1]['OrderBy']=$SubArr[1];
            }
            if ($SubArr[0]=="OrderTo") {
                $GLOBALS['OrderTo'] = $SubArr[1];
                $WhereArr[count($WhereArr)-1]['OrderTo']=$SubArr[1];
            }
        }
    }
    $GLOBALS['WhereArr']=$WhereArr;    
    foreach ($Params as $K=>$V) {
        if ($K=="Limit"||$K=="CpId"||$K=="DynamicPeriod") continue; 
        if ($V=="") continue;
        $GLOBALS[$K]=$V;
    }

    $StaticMode=true;


    $PeriodsArr=array();
    $Periods=array();
    global $DynamicPeriod, $sDynamicPeriod;
    $Query = "SELECT PERIOD FROM ?_static_report_periods WHERE REPORT_ID=? ORDER BY PERIOD";
    $Sql = new Query($Query, false, $ReportId);
    while ($Row=$Sql->Row()) $Periods[]=$Row->PERIOD;
    $Query = "SELECT ID, TEMPLATE, NAME FROM ?_periods WHERE COMPANY_ID IN (0, ?) AND DELETED != '1' ORDER BY TEMPLATE";
    $Sql = new Query($Query, false, $CpId);
    while ($Row=$Sql->Row()) {
        if (!in_array($Row->TEMPLATE,$Periods)) continue;
        if (!$DynamicPeriod) $DynamicPeriod=$Row->TEMPLATE=="0-a-0"?"-1":$Row->TEMPLATE;
        if (!$sDynamicPeriod) $sDynamicPeriod=$Row->TEMPLATE=="0-a-0"?"-1":$Row->TEMPLATE;
        if (!$Row->NAME && isset($Lang[$Row->TEMPLATE])) $Row->NAME=$Lang[$Row->TEMPLATE];
        $PeriodsArr[$Row->TEMPLATE]=$Row->NAME;
    }
    $PArr=array_keys($PeriodsArr);
    usort($PArr,"SortPeriods");
    $PeriodsArr=SyncKeysWValues($PeriodsArr,$PArr);        

    $GLOBALS['ReportPeriods']=$PeriodsArr;

    $SitesArr=array();
    $Sites=explode(";", $Rep->SITES);
    $Query = "SELECT ID, HOST FROM ?_site WHERE COMPANY_ID = ?";
    $Sql = new Query($Query, false, $CpId);
    while ($Row=$Sql->Row()) {
        if (!in_array($Row->ID, $Sites)) continue;
        $SitesArr[$Row->ID]=$Row->HOST;
    }
    if (count($Sites)==1&&in_array("-1",$Sites)) $Sites=array();
    if (in_array("-1", $Sites)) $SitesArr["-1"]=$Lang['AllSites'];
    $GLOBALS['ReportSites']=$SitesArr;

    return $Rep->ID;
}


function ImportArchiveReport($ArchiveId)
{
    global $Db, $CpId,$StaticReportName,$Lang,$ReportDates,$SiteId,$DynamicPeriod, $StartDate, $EndDate;
    global $PrevArchiveId, $NextArchiveId,$StaticReportGroupId;
    
    $Query = "
        SELECT A.*,
            SR.SITES,
            SR.NAME, SR.USER_ID,
            SR.ADDITIONAL_TASK,
            SR.NAME, SR.GROUP_ID,
            DATE_FORMAT(A.START_DATE,'%Y-%m') AS M, DATE_FORMAT(A.START_DATE,'%Y') AS Y,
            UNIX_TIMESTAMP(A.START_DATE) AS START_STAMP,
            UNIX_TIMESTAMP(A.END_DATE) AS END_STAMP
        FROM ?_archive A
            INNER JOIN ?_static_report SR
                ON SR.ID=A.REPORT_ID
        WHERE A.ID=?
    ";
    $Arch=$Db->Select($Query,false,$ArchiveId);
    if (!$Arch) return false;
    if (isset($Lang[$Arch->NAME])) $Arch->NAME=$Lang[$Arch->NAME];
    if ($Arch->FULL_DATA) {
        if (substr($Arch->FULL_DATA,0,1)=='e') $Arch->FULL_DATA=base64_decode($Arch->FULL_DATA);
        $Arch->FULL_DATA=gzuncompress($Arch->FULL_DATA);
        $Arch->FULL_DATA=unserialize($Arch->FULL_DATA);
    }
    //$DynamicPeriod=$Arch->PERIOD;
    $StartDate = date('Y-m-d', $Arch->START_STAMP).' 00:00:00';
    $EndDate = date('Y-m-d', $Arch->END_STAMP).' 23:59:59';
    $SiteId=$Arch->SITE_ID;
    $StaticReportGroupId=$Arch->GROUP_ID;

    $Query = "SELECT ID 
                    FROM ?_archive WHERE REPORT_ID=? AND  COMPANY_ID=? AND SITE_ID=? AND 
                                                        PERIOD=? AND END_DATE<? AND FULL_DATA IS NOT NULL
                    ORDER BY END_DATE DESC 
                    LIMIT 1 ";
    $PrevArchiveId=$Db->ReturnValue($Query,$Arch->REPORT_ID, $Arch->COMPANY_ID,$Arch->SITE_ID,$Arch->PERIOD,
                                                            $Arch->START_DATE);
    $Query = "SELECT ID 
                    FROM ?_archive WHERE REPORT_ID=? AND COMPANY_ID=? AND SITE_ID=? AND 
                                                        PERIOD=? AND START_DATE>? AND FULL_DATA IS NOT NULL
                    ORDER BY START_DATE ASC 
                    LIMIT 1 ";
    $NextArchiveId=$Db->ReturnValue($Query,$Arch->REPORT_ID, $Arch->COMPANY_ID,$Arch->SITE_ID,$Arch->PERIOD,
                                                            $Arch->END_DATE);                                                            

    $Arr=explode("-",$Arch->PERIOD);
    $P=$Arr[1];
    $Num=$Arr[0];    
    if ($P=='d' && $Num=1) $ReportDates[$ArchiveId]=$Arch->START_DATE;
    elseif ($P=='m') $ReportDates[$ArchiveId]= $Arch->M;
    elseif ($P=='y') $ReportDates[$ArchiveId]= $Arch->Y;
    else $ReportDates[$ArchiveId]= $Arch->START_DATE." - ".$Arch->END_DATE;
    
    $StaticReportName=$Arch->NAME;

    $Params=unserialize($Arch->PARAMS_SET);
    $WhereArr=ValidVar($Params['WhereArr']);
    unset($Params['WhereArr']);
    if ($Arch->ADDITIONAL_TASK) {
        $Arr=explode(";",$Arch->ADDITIONAL_TASK);
        foreach ($Arr as $AT) {
            $SubArr=explode("=",$AT);
            if ($SubArr[0]=="OrderBy") $WhereArr[count($WhereArr)-1]['OrderBy']=$SubArr[1];
            if ($SubArr[0]=="OrderTo") $WhereArr[count($WhereArr)-1]['OrderTo']=$SubArr[1];
        }
    }
    $GLOBALS['WhereArr']=$WhereArr;    
    foreach ($Params as $K=>$V) {
        if (in_array($K,array('Limit', 'CpId', 'DynamicPeriod', 'SiteId'))) continue;
        if ($V=="") continue;
        $GLOBALS[$K]=$V;
    }
    
    global $ReportSites, $ReportPeriods;
    
    $Query = "
        SELECT A.SITE_ID, S.HOST
            FROM ?_archive A
            LEFT JOIN ?_site S
                ON S.ID=A.SITE_ID
        WHERE A.COMPANY_ID=? AND A.REPORT_ID=? AND A.PERIOD=?
        GROUP BY A.SITE_ID
    ";
    $Sql= new Query($Query,false,$Arch->COMPANY_ID,$Arch->REPORT_ID,$Arch->PERIOD);
    while ($Row=$Sql->Row()) {
        $ReportSites[$Row->SITE_ID]=$Row->HOST;
    }
    if (count($ReportSites)==1) $ReportSites=array();
    
    $Query = "SELECT DISTINCT PERIOD FROM ?_archive WHERE COMPANY_ID=? AND REPORT_ID=?";
    $Sql = new Query($Query,false,$Arch->COMPANY_ID,$Arch->REPORT_ID);
    while ($Row=$Sql->Row()) {
        $Arr=explode("-",$Row->PERIOD);
        if ($Arr[0]==1) $Row->NAME=$Lang["1".$Arr[1]];
        else $Row->NAME=$Arr[0]." ".$Lang['P'.$Arr[1]];
        $ReportPeriods[$Row->PERIOD]=$Row->NAME;
    }
    
    $PArr=array_keys($ReportPeriods);
    usort($PArr,"SortPeriods");
    $Tmp=array();
    foreach ($PArr as $P) $Tmp[$P]=$ReportPeriods[$P];
    $ReportPeriods=$Tmp;
    
    return $Arch;
}


function CacheByStaticReport($Id,$CpId)
{
        global $Db;
        $Query = "
             SELECT 
                C.ID, QS.PARAMS_SET,
                QS.ID AS QUERY_SET_ID,
                C.CACHE_TYPE,
                SR.NAME, 
                SR.SITES,
                SR.COMPANY_ID, SR.MODE

                FROM ?_static_report SR
                INNER JOIN ?_{$CpId}_static_report_cache SRC
                    ON SRC.REPORT_ID=SR.ID
                INNER JOIN ?_{$CpId}_cache C
                    ON C.ID=SRC.CACHE_ID
                INNER JOIN ?_{$CpId}_cache_query_set QS
                    ON QS.ID=C.QUERY_SET_ID
            WHERE SR.ID = ?
            ORDER BY SRC.ID
        ";
        $Report=$Db->Select($Query,false,$Id);
        if (!$Report) return false;
        $Params=unserialize($Report->PARAMS_SET);
        $WhereArr=$Params['WhereArr'];
        unset($Params['WhereArr']);
        
        
        $Cache = new nsQueryCache($Report->COMPANY_ID);
        $Cache->CacheType=$Report->CACHE_TYPE;
        $Cache->Mode=$Report->MODE;
        $Cache->ReportName=$Report->NAME;
        $Cache->Sites=explode(";", $Report->SITES);
        $Cache->CompanyId=$Report->COMPANY_ID;
        $Cache->Params=$Params;
        $Cache->QuerySetArr=$WhereArr;
        
        $TZ=$Db->ReturnValue("SELECT TIMEZONE FROM ?_config WHERE COMPANY_ID=? AND SITE_ID=0", $Report->COMPANY_ID);
        $TZ=intval($TZ);
        $TZ=0;
        
        $Cache->Periods=array();
        $Query = "SELECT *, UNIX_TIMESTAMP( DATE_ADD(NEXT_UPDATE_TIME, INTERVAL '".SqlTZ($TZ)."' HOUR_MINUTE)) AS STAMP FROM ?_static_report_periods WHERE REPORT_ID=$Id";
        $Sql = new Query($Query);
        while ($Row=$Sql->Row()) {
            $Arr=explode("-",$Row->PERIOD);
            $Row->P=$Arr[2];
            settype($Row,'array');
            $Cache->Periods[$Row['PERIOD']]=$Row;
        }
        
        return $Cache;
}



?>