<?

$SearchFuncs=array(
'vis'=>array('Func'=>'SearchVisitors', 'Title'=>$Lang['Visitors']),
'key'=>array('Func'=>'SearchKeywords', 'Title'=>$Lang['Keywords']),
'item'=>array('Func'=>'SearchItems', 'Title'=>$Lang['Items'])
);
if ($nsProduct->LICENSE != 4) $SearchFuncs['product'] = array('Func'=>'SearchProducts', 'Title'=>$Lang['Products']);
//'setting'=>array('Func'=>'SearchSettings', 'Title'=>$Lang['Settings']),

//           
$SearchPriority=array(
'visitor_path'=>'vis',
'logs:Key'=>'key',
'logs:Ref'=>'key',
'logs:Actions'=>'item',
'logs:Sales'=>'product'
);

function SearchVisitors($Q=false,$QArr=array(),$CountOnly=false,&$Pages,$PerPage=50)
{
    $Result=array();
    if (empty($QArr)) return $CountOnly?0:$Result;
    global $Db,$CpId,$nsUser;

    if (preg_match("/(?:\d{1,3}\.){3}\d{1,3}/",$Q)) {
        $CntQuery = "
            SELECT COUNT(DISTINCT S_LOG.VISITOR_ID) AS CNT
            FROM ?_ip I
            INNER JOIN ?_{$CpId}_stat_log S_LOG ON S_LOG.IP_ID=I.ID
            WHERE I.IP=?
        ";
        $Cnt=$Db->Select($CntQuery,false,$Q);
        if ($CountOnly) return @$Cnt->CNT;
        $Pages = new PageNums(@$Cnt->CNT,$PerPage);
        $Query = "
            SELECT V.ID, I.IP, CV.NAME, 
            UNIX_TIMESTAMP(DATE_ADD(V.LAST_STAMP, INTERVAL '$nsUser->SQL_TZ' HOUR_MINUTE)) AS STAMP
            FROM ?_ip I
            INNER JOIN ?_{$CpId}_stat_log S_LOG ON S_LOG.IP_ID=I.ID
            INNER JOIN ?_visitor V ON V.ID=S_LOG.VISITOR_ID
            LEFT JOIN ?_client_visitor CV
                ON CV.VISITOR_ID=V.ID AND CV.COMPANY_ID='$CpId'
            WHERE I.IP=?
            ORDER BY IF(CV.NAME IS NULL,1,0) ASC, CV.NAME ASC, V.LAST_STAMP DESC
            LIMIT {$Pages->PageStart}, {$Pages->Limit}
        ";
        $Sql = new Query($Query,false,$Q);
    }
    else {
        $Args=array(); $WhereArr=array();
        foreach ($QArr as $i=>$Str) {
            $WhereArr[]="(CV.NAME LIKE ?name$i OR CV.DESCRIPTION LIKE ?descr$i 
                                    OR T.TAG LIKE ?tag$i OR CO.NAME LIKE ?co$i OR CI.NAME LIKE ?ci$i
                                    ".( strval(intval($Q)) == $Q? " OR V.ID = ?id " : "" ).")";
            $Args["name$i"]="%$Str%";
            $Args["descr$i"]="%$Str%";
            $Args["tag$i"]="%$Str%";
            $Args["co$i"]="%$Str%";
            $Args["ci$i"]="%$Str%";
            $Args["id"]="$Q";
        }
        $WhereStr=implode(" AND ",$WhereArr);

        $CntQuery = "
            SELECT COUNT(DISTINCT V.ID) AS CNT
            FROM ?_visitor V
            LEFT JOIN  ?_client_visitor CV ON CV.VISITOR_ID=V.ID AND CV.COMPANY_ID = '$CpId'
            LEFT JOIN ?_visitor_tag_rel VTR ON VTR.VISITOR_ID=V.ID AND VTR.COMPANY_ID='$CpId'
            LEFT JOIN ?_tag T ON T.ID=VTR.TAG_ID
            LEFT JOIN ?_country CO ON CO.ID=V.LAST_COUNTRY_ID
            LEFT JOIN ?_city CI ON CI.ID=V.LAST_CITY_ID
            WHERE $WhereStr
        ";
        $Cnt=$Db->Select($CntQuery,false,$Args);
        if ($CountOnly) return @$Cnt->CNT;
        $Pages = new PageNums(@$Cnt->CNT,$PerPage);        

        $Query = "
            SELECT V.ID, I.IP, CV.NAME, 
            UNIX_TIMESTAMP(DATE_ADD(V.LAST_STAMP, INTERVAL '$nsUser->SQL_TZ' HOUR_MINUTE)) AS STAMP
            FROM ?_visitor V
            LEFT JOIN  ?_client_visitor CV ON CV.VISITOR_ID=V.ID AND CV.COMPANY_ID = '$CpId'
            LEFT JOIN ?_visitor_tag_rel VTR ON VTR.VISITOR_ID=V.ID AND VTR.COMPANY_ID='$CpId'
            LEFT JOIN ?_tag T ON T.ID=VTR.TAG_ID
            LEFT JOIN ?_country CO ON CO.ID=V.LAST_COUNTRY_ID
            LEFT JOIN ?_city CI ON CI.ID=V.LAST_CITY_ID
            INNER JOIN ?_ip I ON I.ID=V.LAST_IP_ID
            WHERE $WhereStr
            ORDER BY IF(CV.NAME IS NULL,1,0) ASC, CV.NAME ASC, V.LAST_STAMP DESC
            LIMIT {$Pages->PageStart}, {$Pages->Limit}
        ";
        $Sql = new Query($Query,false,$Args);
    }

    while ($Row=$Sql->Row()) {
        $Row->Tags=array();
        $Row->CITY_NAME=false;
        $Row->COUNTRY_NAME=false;
        $Result[$Row->ID]=$Row;
    }

    if (!empty($Result)) {
        $Query = "
            SELECT REL.VISITOR_ID, T.TAG
            FROM ?_visitor_tag_rel REL
            INNER JOIN ?_tag T
                ON T.ID=REL.TAG_ID
            WHERE REL.VISITOR_ID IN (?) AND REL.COMPANY_ID=?
        ";
        $Sql = new Query($Query,false,array_keys($Result),$CpId);
        while ($Row=$Sql->Row()) {
            $Result[$Row->VISITOR_ID]->Tags[]=$Row->TAG;
        }
        
        $Query = "
            SELECT V.ID, CO.NAME AS COUNTRY_NAME, CI.NAME AS CITY_NAME
            FROM ?_visitor V
            LEFT JOIN ?_country CO ON CO.ID=V.LAST_COUNTRY_ID
            LEFT JOIN ?_city CI ON CI.ID=V.LAST_CITY_ID
            WHERE V.ID IN (?)
        ";
        $Sql = new Query($Query,false,array_keys($Result));
        while ($Row=$Sql->Row()) {
            $Result[$Row->ID]->COUNTRY_NAME=$Row->COUNTRY_NAME;
            $Result[$Row->ID]->CITY_NAME=$Row->CITY_NAME;
        }
    }
    
    return $Result;
}

function SearchKeywords($Q=false,$QArr=array(),$CountOnly=false,&$Pages,$PerPage=50)
{
    $Result=array();
    if (empty($QArr)) return $CountOnly?0:$Result;
    global $Db,$CpId,$nsUser,$CompArr;

    $WhereArr=array(); $WhereStr=""; $Args=array();
    foreach ($QArr as $i=>$Str) {
        $WhereArr[]="K.KEYWORD LIKE ?k$i";
        $Args["k$i"]="%$Str%";
    }
    $WhereStr=implode(" OR ",$WhereArr);

    if (empty($CompArr) || (is_array($CompArr) && count($CompArr) == 1)) {
        $CntQuery="SELECT COUNT(DISTINCT K.ID) AS CNT FROM ?_keyword K WHERE $WhereStr";
        $Cnt=$Db->Select($CntQuery,false,$Args);
        if ($CountOnly) return @$Cnt->CNT;
        $Pages = new PageNums(@$Cnt->CNT,$PerPage);
    
        $Query = "
            SELECT K.ID, K.KEYWORD
            FROM ?_keyword K
            WHERE $WhereStr
            LIMIT {$Pages->PageStart}, {$Pages->Limit}
        ";
    } else {
        
        $CntQuery="
            SELECT COUNT(DISTINCT K.ID) AS CNT FROM ?_keyword K
                LEFT JOIN ?_{$CpId}_stat_click S_CLICK ON S_CLICK.KEYWORD_ID=K.ID
                LEFT JOIN ?_referer_set RS ON RS.NATURAL_KEY=K.ID
                LEFT JOIN ?_{$CpId}_stat_log S_LOG ON S_LOG.REFERER_SET = RS.ID 
            WHERE (S_LOG.ID IS NOT NULL OR S_CLICK.ID IS NOT NULL) AND ($WhereStr)
        ";
        $Cnt=$Db->Select($CntQuery,false,$Args);
        if ($CountOnly) return @$Cnt->CNT;
        $Pages = new PageNums(@$Cnt->CNT,$PerPage);
    
        $Query = "
            SELECT K.ID, K.KEYWORD FROM ?_keyword K
                LEFT JOIN ?_{$CpId}_stat_click S_CLICK ON S_CLICK.KEYWORD_ID=K.ID
                LEFT JOIN ?_referer_set RS ON RS.NATURAL_KEY=K.ID
                LEFT JOIN ?_{$CpId}_stat_log S_LOG ON S_LOG.REFERER_SET = RS.ID 
            WHERE (S_LOG.ID IS NOT NULL OR S_CLICK.ID IS NOT NULL) AND ($WhereStr)
            LIMIT {$Pages->PageStart}, {$Pages->Limit}
        ";

    }
    $Sql = new Query($Query,false,$Args);
    while ($Row=$Sql->Row()) {
        $Row->KEYWORD=stripslashes($Row->KEYWORD);
        $Row->STAMP=false;
        $Row->NAME=false;
        $Row->VISITOR_ID=false;
        $Row->IP=false;
        $Result[$Row->ID]=$Row;
    }

    /*
    if (!empty($Result)) {
        $Query = "
            SELECT
            RS.NATURAL_KEY,
            UNIX_TIMESTAMP(DATE_ADD(S_LOG.STAMP, INTERVAL '$nsUser->SQL_TZ' HOUR_MINUTE)) AS STAMP,
            CV.NAME, S_LOG.VISITOR_ID, I.IP
            FROM ?_referer_set RS
            INNER JOIN ?_{$CpId}_stat_log S_LOG ON S_LOG.REFERER_SET=RS.ID
            INNER JOIN ?_visitor V ON V.ID=S_LOG.VISITOR_ID
            INNER JOIN ?_ip I ON I.ID=S_LOG.IP_ID
            LEFT JOIN ?_client_visitor CV ON CV.VISITOR_ID=V.ID AND CV.COMPANY_ID='$CpId'
            WHERE RS.NATURAL_KEY IN (?)
            GROUP BY RS.NATURAL_KEY
            ORDER BY RS.ID DESC, S_LOG.STAMP DESC 
        ";
        $Sql = new Query($Query,false,array_keys($Result));
        while ($Row=$Sql->Row()) {
            $Result[$Row->NATURAL_KEY]->STAMP=$Row->STAMP;
            $Result[$Row->NATURAL_KEY]->NAME=$Row->NAME;
            $Result[$Row->NATURAL_KEY]->VISITOR_ID=$Row->VISITOR_ID;
            $Result[$Row->NATURAL_KEY]->IP=$Row->IP;
        }
    }
    */

    return $Result;
}

function SearchProducts($Q=false,$QArr=array(),$CountOnly=false,&$Pages,$PerPage=50)
{
    $Result=array();
    if (empty($QArr)) return $CountOnly?0:$Result;
    global $Db,$CpId,$nsUser;
    
    $WhereArr=array(); $WhereStr=""; $Args=array();
    foreach ($QArr as $i=>$Str) {
        $WhereArr[]="SI.NAME LIKE ?k$i";
        $Args["k$i"]="%$Str%";
    }
    $WhereStr=implode(" OR ",$WhereArr);

    $CntQuery="SELECT COUNT(DISTINCT SI.ID) AS CNT FROM ?_sale_item SI WHERE 
                    SI.COMPANY_ID='$CpId' AND ($WhereStr)";
    $Cnt=$Db->Select($CntQuery,false,$Args);
    if ($CountOnly) return @$Cnt->CNT;
    $Pages = new PageNums(@$Cnt->CNT,$PerPage);

    $Query = "
        SELECT SI.ID, SI.NAME
        FROM ?_sale_item SI
        WHERE SI.COMPANY_ID='$CpId' AND ($WhereStr) 
        LIMIT {$Pages->PageStart}, {$Pages->Limit}
    ";
    $Sql = new Query($Query,false,$Args);
    while ($Row=$Sql->Row()) {
        $Row->NAME=stripslashes($Row->NAME);
        $Result[$Row->ID]=$Row;
    }
    
    return $Result;
}

function SearchItems($Q=false,$QArr=array(),$CountOnly=false,&$Pages,$PerPage=50)
{
    $Result=array();
    if (empty($QArr)) return $CountOnly?0:$Result;
    global $Db,$CpId,$nsUser;
    
    $WhereArr=array(); $WhereStr=""; $Args=array();
    foreach ($QArr as $i=>$Str) {
        $WhereArr[]="AI.NAME LIKE ?k$i";
        $Args["k$i"]="%$Str%";
    }
    $WhereStr=implode(" OR ",$WhereArr);

    $CntQuery="SELECT COUNT(DISTINCT AI.ID) AS CNT FROM ?_action_item AI WHERE 
                    AI.COMPANY_ID='$CpId' AND ($WhereStr)";
    $Cnt=$Db->Select($CntQuery,false,$Args);
    if ($CountOnly) return @$Cnt->CNT;
    $Pages = new PageNums(@$Cnt->CNT,$PerPage);

    $Query = "
        SELECT AI.ID, AI.NAME
        FROM ?_action_item AI
        WHERE AI.COMPANY_ID='$CpId' AND ($WhereStr) 
        LIMIT {$Pages->PageStart}, {$Pages->Limit}
    ";
    $Sql = new Query($Query,false,$Args);
    while ($Row=$Sql->Row()) {
        $Row->NAME=stripslashes($Row->NAME);
        $Result[$Row->ID]=$Row;
    }
    
    return $Result;
}


function SearchSettings($Q=false,$QArr=array(),$CountOnly=false,&$Pages,$PerPage=50)
{
    $Result=array();
    $Pages = new PageNums();
    if (empty($QArr)) return $CountOnly?0:$Result;
    if ($CountOnly) return 0;
    return $Result;
}


function PrepareSearchQuery($Q)
{
    $Q=preg_replace("/[^\w]/"," ",$Q);
    $Q=preg_replace("/\t/"," ",$Q);
    $Q=preg_replace("/\s\s/"," ",$Q);
    $Arr=explode(" ",$Q);
    $Arr2=array();
    foreach ($Arr as $Str) if (strlen($Str)>2) $Arr2[]=$Str;
    return $Arr2;
}

//       
function SortSearchArray(&$Array,$Key)
{
    $NewArray=array();
    $i=0;
    foreach ($Array as $k=>$v) {
        if ($i==0&&$k==$Key) return $Array;
        $i++;
        if ($k==$Key) {$NewArray[$k]=&$Array[$k]; break;}
    }
    foreach ($Array as $k=>$v) {
        if($k==$Key) continue;
        $NewArray[$k]=&$Array[$k];
    }
    return $NewArray;
}

?>