<?
# ============================================================================
#
#                        ___
#                    ,yQ$SSS$Q,      ,yQQQL
#                  j$$"`     `?$'  ,d$P"```$$,
#           i_L   I$;            `$`       `$$,
#                                 `          I$$
#           .yQ$$$$,            ;        _,d$$'
#        ,d$$P"^```?$b,       _,'  ;  ,d$$P"`
#     ,d$P"`        `"?$$Q#QP`    $d$$P"`
#   ,$$"         ;       ``       ;$?'
#   $$;        ,dI                I$;
#   `$$,    ,d$$$`               j$I
#     ?$S#S$P'j$'                $$;         Copyright (c) Stuffed Guys
#       `"`  j$'  __....,,,.__  j$I              www.stuffedguys.com
#           j$$"``           ',$$
#           I$;               ,$$'
#           `$$,         _.u$$`
#             "?$$Q##Q$$SP"^`
#                `````
#

// nsUser. The session contains:
// 1. the session id(generated by "uniqid"),
// 2. user agent,
// 3. IP-address(md5-ed)
//  IP-address will be updated on change
// ::::::::::::::::::::::::::
// ON CREATING the class should check if this user is authorized by session


class nsUser extends nsBase{


	var $UserInfo; // contains all the user info(in array)
	var $Authorized;// it is clear
	var $Logged;// it is also clear
	var $sessid; // the current user session ID. It exists even if user is anonymous
	var $CheckByChangingIP; // the current user session ID. It exists even if user is anonymous


	function nsUser(){
		$this->CheckByChangingIP(true);
		$this->__CheckAuth();
	}


	function Login($login, $pwd, $recall = false, $md5pass=false){
		global $Db, $nsSession, $Logs, $Lang;
		$query = 'SELECT * FROM ?{PFX}_system_user WHERE LOGIN = ?';
		$this->UserInfo = $Db->Select($query, 'ARR', $login);
        $passcheck = ($md5pass)?$pwd:md5($pwd);
		// let's check him:
        if ( isset($this->UserInfo['PWD']) &&
                        $this->UserInfo['PWD'] == $passcheck &&
                        empty($this->UserInfo['DISABLED']) ) {
			// this is the right user!
			$nsSession->set('ns_tracker_user_auth_uid', $this->UserId());
			$nsSession->set('ns_tracker_user_auth_uinf', $this->UserMd5());
			$this->Logged = true;
			$this->Init();
			// recall was requested, writing user id and password in the cookie
			if ($recall && !defined("COMMAND_LINE")) {
				$this->SetCookie(COOKIE_PFX.'tracker_uid', $this->UserId(), time()+60*60*24*365*10, '/');
				$this->SetCookie(COOKIE_PFX.'tracker_pwd', md5($pwd), time()+60*60*24*365*10, '/');
			}
		} else {
			// let's see why:
            if (!isset($this->UserInfo['ID'])) $Logs->Err($Lang['NoUser']);
            else if ($this->UserInfo['PWD'] != $pwd) $Logs->Err($Lang['WrongPwd']);
            else if (!empty($this->UserInfo['DISABLED'])) { $Logs->Error('USER:DISABLED'); }

			// ereasing all possible user info
			$this->Logout();
		}
		return $this->Logged;
	}


	// sets if
	function CheckByChangingIP($yesno){
		$this->CheckByChangingIP = $yesno;
	}


	// authorized?
	function Authorized(){
		return $this->Authorized;
	}


	// authorized?
	function Logged() {
        return $this->Logged;
    }


	// returns user ID, or sets the user id (if argument is set)
	function UserId($bySess=false){
		global $nsSession;
		if($bySess) return $nsSession->get('ns_tracker_user_auth_uid');
		return isset($this->UserInfo['ID']) ? $this->UserInfo['ID'] : 0;
	}


	function Init(){
		global $nsProduct, $nsLang, $Db;
		//$nsProduct->Initialize($this->UserInfo['ID']);
		$query = "SELECT * FROM ?{PFX}_system_user2lang WHERE UID=? AND PROD_ID=?";
		$ulang = $Db->Select($query,'ARR', $this->UserInfo['ID'], $nsProduct->ID);
		if(isset($ulang['LANG']))	$nsLang->InitLang($ulang['LANG']);
		$this->ULANG=$ulang['LANG'];

		$uskin=false;
		$Query = "SELECT SKIN FROM ?{PFX}_system_user2skin WHERE UID=? AND PROD_ID=?";
		$uskin=$Db->ReturnValue($Query, $this->UserInfo['ID'], $nsProduct->ID);
		if ($uskin) $nsProduct->SKIN=$uskin;
		$this->USKIN=$uskin;
	}


	// unauthorizes and authorized the client again
	function Reauthorize(){
		$this->__Authorize();
	}


	// returns user session ID
	function SessionId(){
		return $this->sessid;
	}


	// throws the user away from the system.
	function Logout(){
		global $nsSession;

		if (isset($_SESSION['ns_tracker_user_auth_uid'])) $nsSession->set('ns_tracker_user_auth_uid');
		if (isset($_SESSION['ns_tracker_user_auth_uinf'])) $nsSession->set('ns_tracker_user_auth_uinf');
		if (isset($_COOKIE[COOKIE_PFX.'tracker_uid'])) $this->SetCookie(COOKIE_PFX.'tracker_uid', '', time()-60*60*24*365*10, '/');
		if (isset($_COOKIE[COOKIE_PFX.'tracker_pwd'])) $this->SetCookie(COOKIE_PFX.'tracker_pwd', '', time()-60*60*24*365*10, '/');
		if (isset($_COOKIE[COOKIE_PFX.'tracker_user_auths'])) $this->SetCookie(COOKIE_PFX.'tracker_user_auths', '', time()-60*60*24*365*10, '/');

		$this->Logged = false;
		$this->UserInfo = array();
	}


	// returns user md5 entry (user id and pwd)
	function UserMd5(){
		return md5($this->UserId().@$this->UserInfo['PWD']);
	}



	// logging user by session user session
	function __CheckUser(){
		global $Db, $nsSession;

		if($this->UserId(true)){
			$query = "SELECT * FROM ?{PFX}_system_user WHERE ID=?";
			$this->UserInfo = $Db->Select($query,'ARR',$this->UserId(true));
		}
		// do we have the session var?
		if( $nsSession->get('ns_tracker_user_auth_uid') == $this->UserId() && $nsSession->get('ns_tracker_user_auth_uinf') == $this->UserMd5()) {
			// this is the right user!
			$this->Logged = true;
			$this->Init();
		}
		// checking if the user have login and pwd in the cookie
		elseif (isset($_COOKIE[COOKIE_PFX.'tracker_uid']) && isset($_COOKIE[COOKIE_PFX.'tracker_pwd'])) {
			$uid = $_COOKIE[COOKIE_PFX.'tracker_uid'];
			$md5_pwd = $_COOKIE[COOKIE_PFX.'tracker_pwd'];
			$this->UserInfo = $Db->Select('SELECT * FROM ?{PFX}_system_user WHERE ID = ?', 'ARR', $uid);
			if (isset($this->UserInfo['PWD']) and $this->UserInfo['PWD'] == $md5_pwd and empty($this->UserInfo['DISABLED'])) {
                $this->Logged = true;
				$this->Init();
				// prolonging cookie for another 10 years
                if (!defined("COMMAND_LINE")) {
				    $this->SetCookie(COOKIE_PFX.'tracker_uid', $uid, time()+60*60*24*365*10, '/');
				    $this->SetCookie(COOKIE_PFX.'tracker_pwd', $md5_pwd, time()+60*60*24*365*10, '/');
                }
			}
		}
		// erasing all possible user info
		else {
			$this->Logout();
		}
		return $this->Logged;
	}


    function CLineAuth()
    {
        global $Db, $Settings, $nsProduct;
        $Key = @$Settings['All']->AUTH_KEY;
        if (!$Key) $Key = $Db->ReturnValue('SELECT AUTH_KEY FROM ?_config WHERE COMPANY_ID=0 AND SITE_ID=0');
        $Auth=$_REQUEST['CLineAuth'];
        $Query = "SELECT * FROM ?{PFX}_system_user";
        $Sql = new Query($Query);
        while ($Check=$Sql->Row()) {
            if (md5($Check->LOGIN.$Key.$Check->PWD)==$Auth) {
                return $this->Login($Check->LOGIN, $Check->PWD, false, true);
            }
        }
        if (defined('CRON_MODE')) exit;
        else $nsProduct->Redir('default', '', 'admin');
    }

    function GetMd5Id($Id="")
    {
        $MaxLen=4;
        $CurLen=strlen($Id);
        for($i=0;$i<($MaxLen-$CurLen);$i++) $Id.="0";
        return md5($Id);
    }

    function GetClientAuth()
    {
        global $Settings;
        $Key = @$Settings['All']->AUTH_KEY;
        return md5($this->UserInfo['LOGIN'].$Key.$this->UserInfo['PWD']);
    }

	// checks and sets common authorization.
	function __CheckAuth()
    {
		global $Db, $nsSession;
		if (!$Db->ID) {
			$this->Authorized=false;
			return false;
		}
        if (V($_REQUEST['CLineAuth']))  $this->CLineAuth();

		// has the session been set?
		elseif(!isset($this->sessid)){
			$this->sessid = $nsSession->get('ns_tracker_user_auth_sess');
			// OK, now checkin' the session info:
			if($nsSession->get('ns_tracker_user_auths') == md5(V($_SERVER['HTTP_USER_AGENT']).$_SERVER['REMOTE_ADDR'])){
				$this->Authorized = true;
			    // oh, this user has wrong check-entry. Maybe changed?
			}
            else if( $this->CheckByChangingIP &&
			     isset($_COOKIE[COOKIE_PFX . 'tracker_user_auths']) &&
				$nsSession->get('ns_tracker_user_auths') == $_COOKIE[COOKIE_PFX . 'tracker_user_auths']	) {

				// Did change. Rewriting the session entry (and cookie also):
				$this->__Authorize(true);
				$this->Authorized = true;
			} else // it is really wrong Authorization. Creating a new one:
				$this->__Authorize();
		}
		// session had not been set!
		if(!$this->sessid) $this->__Authorize();

		// Delivering control to user check:
		$this->__CheckUser();
	}



	function VisitorCookie($Cookie=false)
	{
		$Domain=false;
		if (defined("COOKIE_DOMAIN")) $Domain=COOKIE_DOMAIN;
		if ($Cookie) {
			$this->SetCookie(COOKIE_PFX.'visitor', $Cookie, time()+60*60*24*10*365, "/", $Domain);
			return $Cookie;
		}
		global $_COOKIE;
		if (isset($_COOKIE[COOKIE_PFX.'visitor'])) return $_COOKIE[COOKIE_PFX.'visitor'];
		else {
			$Cookie=$this->CookieId();
			$this->SetCookie(COOKIE_PFX.'visitor', $Cookie, time()+60*60*24*10*365, "/", $Domain);
			return $Cookie;
		}
	}



	function CookieId()
	{
		return substr(md5(uniqid(rand())), 0, 32);
	}



	function VisitorAgent()
	{
		global $_SERVER;
		return V($_SERVER['HTTP_USER_AGENT']);
	}



	// Authorizing client
	function __Authorize($OnlyResetUaIpEntry=false){
		global $nsSession;
		if(!$OnlyResetUaIpEntry) {
			// very hard-to-guess sequense
			$this->sessid = md5(uniqid(rand(), true));
			$nsSession->set('ns_tracker_user_auth_sess', $this->sessid);
		}
		$entry = md5($_SERVER['HTTP_USER_AGENT'].$_SERVER['REMOTE_ADDR']);
		$nsSession->set('ns_tracker_user_auths', $entry);
		if($this->CheckByChangingIP && !defined("COMMAND_LINE") && !defined("NO_SESSION"))
			$this->SetCookie(COOKIE_PFX.'tracker_user_auths',  $entry, time()+intval(COOKIE_EXP), '/');
	}

}
?>