<?
# ============================================================================
#
#                        ___
#                    ,yQ$SSS$Q,      ,yQQQL
#                  j$$"`     `?$'  ,d$P"```$$,
#           i_L   I$;            `$`       `$$,
#                                 `          I$$
#           .yQ$$$$,            ;        _,d$$'
#        ,d$$P"^```?$b,       _,'  ;  ,d$$P"`
#     ,d$P"`        `"?$$Q#QP`    $d$$P"`
#   ,$$"         ;       ``       ;$?'
#   $$;        ,dI                I$;
#   `$$,    ,d$$$`               j$I
#     ?$S#S$P'j$'                $$;         Copyright (c) Stuffed Guys
#       `"`  j$'  __....,,,.__  j$I              www.stuffedguys.com
#           j$$"``           ',$$
#           I$;               ,$$'
#           `$$,         _.u$$`
#             "?$$Q##Q$$SP"^`
#                `````
#


function TextDump(&$Var, $Level = 0)
{
	if(is_array($Var)) $Type = "Array[".count($Var)."]";
	else if (is_object($Var)) $Type = "Object";
	else $Type = "";

	if ($Type)
	{
		echo "$Type\n";
		for (Reset($Var), $Level++; list($k, $v) = each($Var);)
		{
			if (is_array($v) && $k === "GLOBALS") continue;
			for ($i = 0; $i < $Level*3; $i++) echo " ";
			echo "<b>- [".htmlspecialchars($k)."]</b> => ", TextDump($v, $Level);
		}
	}
	//else echo ' " ', ereg_replace("[[:space:]]+", " ", htmlspecialchars($Var)), ' " '."\n";
	else echo "'".nl2br(htmlspecialchars($Var))."'\n";
}

function Dump(&$Var, $full=false)
{
	if ((is_array($Var) || is_object($Var)) && count($Var)) echo "<pre>\n",TextDump($Var),"</pre><br>\n";
	else echo "<tt>",TextDump($Var),"</tt>\n";
}


function ValidId(&$id)
{
    if ( !isset($id) )
        return false;

    if ( !is_integer($id) && !is_string($id) )
        return false;

    if ( is_string($id) && strval(intval($id)) != $id )
        return false;

    if ( !(intval($id) >= 0) )
        return false;

    return true;
}

function ValidVar(&$Var, $defval=false)
{
	if (empty($Var)) return $defval;
	return $Var;
}

function V(&$Var, $defval=false)
{
    return (empty($Var))?$defval:$Var;
}

//  ValuesArr  ,  Arr    
// Arr    =>  
function VPack($Arr=array(),$ValuesArr=array()) 
{
    $NoDefValues=true;
    $Return = array();
    foreach ($Arr as $k=>$v) {
        if ( strval(intval($k)) != $k) {$NoDefValues = false; break;} 
    }
    if ($NoDefValues && empty($ValuesArr)) foreach ($Arr as $k) $Return[$k] = V($_REQUEST[$k],false); 
    elseif (!empty($ValuesArr)) foreach ($Arr as $k) $Return[$k] = V($_REQUEST[$k],V($ValuesArr[$k], false));
    else foreach ($Arr as $k=>$v) $Return[$k] = V($_REQUEST[$k],$v); 
    return $Return;
}

function ValidReqVar($name, $defval=false)
{
	return ValidVar($_REQUEST[$name], $defval);	
}

function UrlValidReqVar($name, $defval=''){
	return (ValidReqVar($name))? ('&'.$name.'='.ValidReqVar($name)):'';
}

function ValidArr(&$Arr)
{
	if (!isset($Arr)) return false;
	if (!is_array($Arr)) return false;
	return true;
}


function FileSizeStr($Size)
{
	if ($Size < 1024) {
		return $Size." b";
	}
	if ($Size >= 1024 && $Size < 1048576) {
		$Str = round($Size/1024, 2);
		return $Str." Kb";
	}
	if ($Size >= 1048576) {
		$Str = round($Size/1048576, 2); 
		return $Str." Mb";
	}
}

function GetURL($Action=false, $Get=false, $Section=false)
{
	global $nsProduct;
	return $nsProduct->GetUrl($Action, $Get, $Section);
}

function Redir($Url=false) 
{
    if (!$Url) $Url=$_SERVER['REQUEST_URI'];
    Header("Location: $Url"); 
    exit; 
}


function GetFORM($Action=false, $Get=false, $Section=false, $Attr=false)
{
	global $nsProduct;
	$nsProduct->CreateForm("get", $Action, $Get, $Section, $Attr);
}

function PostFORM($Action=false, $Get=false, $Section=false, $Attr=false)
{
	global $nsProduct;
	$nsProduct->CreateForm("post", $Action, $Get, $Section, $Attr);
}


function GetParam($Name, $Type)
{
	global $Db, $nsProduct;
	if (!$Name||!$Type) return false;
	if (!in_array($Type,array("INTVAL","STRVAL","MEMO"))) return false;
	$Prd = ($nsProduct->ID>0)? $nsProduct->ID : "NULL";
	$Name = ereg_replace("[^[:alnum:]_]", "", $Name);
	$Query = "SELECT $Type FROM ?{PFX}_system_config WHERE PRODUCT_ID=? AND CALLNAME=? AND DATATYPE=?";
	return stripslashes($Db->ReturnValue($Query,$Prd,$Name,$Type));
}

function SetParam($Name, $Type, $Value)
{
	global $Db, $nsProduct;
    if (!$Name||!$Type) return false;
    if (!in_array($Type,array("INTVAL","STRVAL","MEMO"))) return false;
	$Prd = ($nsProduct->ID>0)? $nsProduct->ID : "NULL";
	$Query = "SELECT ID FROM ?{PFX}_system_config WHERE PRODUCT_ID=? AND CALLNAME=?";
	$Id = $Db->ReturnValue($Query,$Prd,$Name);
	$Name = ereg_replace("[^[:alnum:]_]", "", $Name);
	if (ValidId($Id)) {
		$Query = "UPDATE ?{PFX}_system_config SET $Type = ?, DATATYPE = ? WHERE PRODUCT_ID=? AND CALLNAME=?";
        $Db->Query($Query,$Value,$Type,$Prd,$Name);
	}
	else {
		$Query = "INSERT INTO ?{PFX}_system_config 
            (PRODUCT_ID, CALLNAME, DATATYPE, $Type) VALUES (?, ?, ?, ?)";
        $Db->Query($Query,$Prd,$Name,$Type,$Value);
	}
}

function DropParam($Name)
{
	global $Db, $nsProduct;
	$Prd=($nsProduct->ID>0)?$nsProduct->ID:"0";
	$Name=ereg_replace("[^[:alnum:]_]", "", $Name);
	$Query = "DELETE FROM ".PFX."_system_config WHERE CALLNAME = ? AND PRODUCT_ID = ?";
	$Db->Query($Query,$Name,$Prd);
}



//$Words[1][0] = ""; - .. - ..
//$Words[1][1] = ""; - ..
//$Words[1][2] = ""; - .. - ..

function ParseNumber($Num, $Word = 1)
{
	global $Words;
	$Num=abs($Num);
	$Rem = $Num % 10;
	if ($Num > 10 && $Num < 20) {
		return $Words[$Word][0];
	}
	else {
		switch ($Rem)
		{
			    case 0:
				case 5:
				case 6:
				case 7:
				case 8:
				case 9:
						return $Words[$Word][0];
				case 1:
					    return $Words[$Word][1];
				case 2:
				case 3:
				case 4:
					     return $Words[$Word][2];
		}
	}
}

function ParseNumberNow($Num, $WordN, $Word1, $Word2){
	global $Words;
	$Words['ParseNumberNow temp'][0] = $WordN;
	$Words['ParseNumberNow temp'][1] = $Word1;
	$Words['ParseNumberNow temp'][2] = $Word2;
	return ParseNumber($Num, 'ParseNumberNow temp');
}



function escape_string($Str){
    if (is_array($Str)) {
        var_dump($Str);
        return '';
    }
    if (is_null($Str) || $Str===false) return "";        
    if (version_compare(phpversion(),"4.3.0")=="-1") return mysql_escape_string($Str);
    else return mysql_real_escape_string($Str);
}

function es($Var=false) {return is_array($Var)?EscapeArray($Var):escape_string($Var); }

function EscapeArray($Array=array()) {
    foreach ($Array as $k=>$v) $Array[$k]="'".escape_string($v)."'";
    return $Array;
}


function ns_my_url_enc(){ return urlencode(ns_my_url()); }
function ns_my_url(){
	return 'http'.((strtolower(ValidVar($_SERVER["HTTPS"]))=="on") ? 's' : '').'://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
}

/**
 * @return string
 * @param string_or_array $varname
 * @param string $url
 * @desc  ,   "strip_certain_req_var_one",  
 * "$var"      
 *  "$url"   -    .
*/
function strip_certain_req_vars($var, $url=''){
	if(empty($url)) $url = ns_my_url();
	if (!is_array($var)) $var = array($var);
	foreach($var as $v)	$url = strip_certain_req_var_one($v, $url);			
	return $url;
}
/**
 * @return string
 * @param string $varname
 * @param string $url
 * @desc  ,    "$url",  
 *  ,    "$var".
*/
function strip_certain_req_var_one($var, $url=''){
    if(empty($url)) $url = ns_my_url();
    
	$ret = '';
	if(strpos($url, '?')!==false)
		list($host, $query) = explode('?', $url);
	else return $url;
	
	if(strpos($url, '&')!==false)
		$pairs = explode('&', $query);
	else 	$pairs[0] = $query;
	if (isset($pairs) && is_array($pairs)) {
		foreach ($pairs as $pair) {
			// here was a bug, $pair could contain nothing when in URL there was a
			// structure like this: &some_param=1&&another_param=2 -- note 2 &
			if (!$pair) continue;
			@list($key, $val) = explode('=', $pair);
            // Also process array-based keys, e.g. name[abc].
			if ($key != $var && strpos($key, $var.'[')!==0 && strpos($key, $var.'%5B')!==0) {
                $ret .= (!empty($ret) ? '&' : '') . $pair;
            }
		}
	}
	return $host . '?' . $ret; 
}

if(!function_exists('is_executable')){
	function is_executable($a){ return false; }
}

function timeintval($a){ return ($a<10?('0'.intval($a)):intval($a)); }

if (version_compare(phpversion(), '5.0') < 0) { 
    eval('
    function clone($object) {
      return $object;
    }
    ');
}


function _htmlspecialchars($Str=false)
{
    if (!$Str&&strlen($Str)==0) return "";
    $Str=htmlspecialchars($Str);
    $Str=preg_replace("/&amp;#(\w{4})/", "&#\\1", $Str);
    return $Str;
}



///   
///   1.0.1  1.1.2
///  -1    
/// 0 -  
/// 1 -   
/// $Position -    
///   ,  version_compare  
function CompareVersions($Str1="", $Str2="", $Position=false)
{
	if (!$Str1&&!$Str2) return 0;
	if (!$Position&&function_exists("version_compare")) {
		return version_compare($Str1, $Str2);
	}
	if (!$Str2) return 1;
	if (!$Str1) return -1;
	if ($Str1==$Str2) return 0;

	$Arr1=explode(".", $Str1);
	$Arr2=explode(".", $Str2);

	if (count($Arr1)!=count($Arr2)) {
		if (count($Arr1)>count($Arr2)) {
			for ($i=count($Arr2);$i<count($Arr1);$i++) $Arr2[$i]=0;
		}
		else {
			for ($i=count($Arr1);$i<count($Arr2);$i++) $Arr1[$i]=0;
		}
	}
	$iStop=($Position)?$Position:count($Arr1);
	for ($i=0;$i<$iStop;$i++) {
		$V1=intval($Arr1[$i]);
		$V2=intval($Arr2[$i]);
		if ($V1==$V2) continue;
		if ($V1<$V2) return -1;
		if ($V1>$V2) return 1;
	}

	return 0;
}


function GetCpuLoad($Check=false, $NoComment=false)
{
    if (!PHP_OS) return ($Check)?-1:0;
    if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN') {
        global $Settings;
        if (!$Settings || !trim(ValidVar($Settings['All']->CPU_AVG_PATH))) return ($Check)?-1:0;
        $Data=@exec("\"".$Settings['All']->CPU_AVG_PATH."\"");
    }
    else $Data = @exec("uptime");
    if (!$Data) return ($Check)?-1:0;
    if (!$NoComment&&!$Check) echo $Data."\n";
    $Arr=array();
    @preg_match_all("/\d+[,\.]\d+/",$Data,$Arr);
    if (!isset($Arr[0][0])) return ($Check)?-1:0;
    $Data=$Arr[0][0];
    $Data=str_replace(",",".",$Data);
    return trim($Data);
}


?>